/* Server.c generated by valac 0.56.17, the Vala compiler
 * generated from Server.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary Developers (https://launchpad.net/elementary)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <polkit/polkit.h>

#define LOGIN_DHELPER_SERVER_CONFIG_FILE "/etc/systemd/logind.conf"
#define LOGIN_DHELPER_SERVER_CONFIG_GROUP "Login"
#define LOGIN_DHELPER_SERVER_ACTION_ID "io.elementary.settings.power.administration"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define LOGIN_DHELPER_TYPE_SERVER (login_dhelper_server_get_type ())
#define LOGIN_DHELPER_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServer))
#define LOGIN_DHELPER_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServerClass))
#define LOGIN_DHELPER_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LOGIN_DHELPER_TYPE_SERVER))
#define LOGIN_DHELPER_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LOGIN_DHELPER_TYPE_SERVER))
#define LOGIN_DHELPER_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServerClass))

typedef struct _LoginDHelperServer LoginDHelperServer;
typedef struct _LoginDHelperServerClass LoginDHelperServerClass;
typedef struct _LoginDHelperServerPrivate LoginDHelperServerPrivate;
enum  {
	LOGIN_DHELPER_SERVER_0_PROPERTY,
	LOGIN_DHELPER_SERVER_PRESENT_PROPERTY,
	LOGIN_DHELPER_SERVER_NUM_PROPERTIES
};
static GParamSpec* login_dhelper_server_properties[LOGIN_DHELPER_SERVER_NUM_PROPERTIES];
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define POWER_TYPE_DBUS (power_dbus_get_type ())
#define POWER_DBUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_DBUS, PowerDBus))
#define POWER_IS_DBUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_DBUS))
#define POWER_DBUS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_DBUS, PowerDBusIface))

typedef struct _PowerDBus PowerDBus;
typedef struct _PowerDBusIface PowerDBusIface;

#define POWER_TYPE_DBUS_PROXY (power_dbus_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL,
	LOGIN_DHELPER_SERVER_CHANGED_SIGNAL,
	LOGIN_DHELPER_SERVER_NUM_SIGNALS
};
static guint login_dhelper_server_signals[LOGIN_DHELPER_SERVER_NUM_SIGNALS] = {0};

struct _LoginDHelperServer {
	GObject parent_instance;
	LoginDHelperServerPrivate * priv;
};

struct _LoginDHelperServerClass {
	GObjectClass parent_class;
};

struct _LoginDHelperServerPrivate {
	GKeyFile* file;
	gboolean _present;
};

struct _PowerDBusIface {
	GTypeInterface parent_iface;
	guint32 (*get_connection_unix_process_id) (PowerDBus* self, const gchar* name, GError** error);
	guint32 (*get_connection_unix_user) (PowerDBus* self, const gchar* name, GError** error);
};

static gint LoginDHelperServer_private_offset;
static gpointer login_dhelper_server_parent_class = NULL;
static LoginDHelperServer* login_dhelper_server_instance;
static LoginDHelperServer* login_dhelper_server_instance = NULL;
static PowerDBus* login_dhelper_server_bus_proxy;
static PowerDBus* login_dhelper_server_bus_proxy = NULL;

VALA_EXTERN GType login_dhelper_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LoginDHelperServer, g_object_unref)
VALA_EXTERN guint login_dhelper_server_register_object (void* object,
                                            GDBusConnection* connection,
                                            const gchar* path,
                                            GError** error);
VALA_EXTERN GType power_dbus_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_dbus_register_object (void* object,
                                  GDBusConnection* connection,
                                  const gchar* path,
                                  GError** error);
VALA_EXTERN GType power_dbus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PowerDBus, g_object_unref)
VALA_EXTERN LoginDHelperServer* login_dhelper_server_get_default (void);
VALA_EXTERN LoginDHelperServer* login_dhelper_server_new (void);
VALA_EXTERN LoginDHelperServer* login_dhelper_server_construct (GType object_type);
VALA_EXTERN void login_dhelper_server_set_key (LoginDHelperServer* self,
                                   const gchar* key,
                                   const gchar* value,
                                   const char* sender,
                                   GError** error);
static gboolean login_dhelper_server_get_sender_is_authorized (const char* sender);
VALA_EXTERN gchar* login_dhelper_server_get_key (LoginDHelperServer* self,
                                     const gchar* key,
                                     GError** error);
VALA_EXTERN gchar* login_dhelper_server_get_config_file (LoginDHelperServer* self,
                                             GError** error);
VALA_EXTERN guint32 power_dbus_get_connection_unix_process_id (PowerDBus* self,
                                                   const gchar* name,
                                                   GError** error);
VALA_EXTERN guint32 power_dbus_get_connection_unix_user (PowerDBus* self,
                                             const gchar* name,
                                             GError** error);
VALA_EXTERN gboolean login_dhelper_server_get_present (LoginDHelperServer* self);
static GObject * login_dhelper_server_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void login_dhelper_server_finalize (GObject * obj);
static GType login_dhelper_server_get_type_once (void);
static void _vala_login_dhelper_server_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _dbus_login_dhelper_server_set_key (LoginDHelperServer* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_login_dhelper_server_get_key (LoginDHelperServer* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_login_dhelper_server_get_config_file (LoginDHelperServer* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void login_dhelper_server_dbus_interface_method_call (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* method_name,
                                                      GVariant* parameters,
                                                      GDBusMethodInvocation* invocation,
                                                      gpointer user_data);
static GVariant* login_dhelper_server_dbus_interface_get_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GError** error,
                                                            gpointer user_data);
static GVariant* _dbus_login_dhelper_server_get_present (LoginDHelperServer* self);
static gboolean login_dhelper_server_dbus_interface_set_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GVariant* value,
                                                           GError** error,
                                                           gpointer user_data);
static void _dbus_login_dhelper_server_changed (GObject* _sender,
                                         gpointer* _data);
static void _login_dhelper_server_unregister_object (gpointer user_data);

static const GDBusArgInfo _login_dhelper_server_dbus_arg_info_set_key_key = {-1, "key", "s", NULL};
static const GDBusArgInfo _login_dhelper_server_dbus_arg_info_set_key_value = {-1, "value", "s", NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_set_key_in[] = {&_login_dhelper_server_dbus_arg_info_set_key_key, &_login_dhelper_server_dbus_arg_info_set_key_value, NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_set_key_out[] = {NULL};
static const GDBusMethodInfo _login_dhelper_server_dbus_method_info_set_key = {-1, "SetKey", (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_set_key_in), (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_set_key_out), NULL};
static const GDBusArgInfo _login_dhelper_server_dbus_arg_info_get_key_key = {-1, "key", "s", NULL};
static const GDBusArgInfo _login_dhelper_server_dbus_arg_info_get_key_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_get_key_in[] = {&_login_dhelper_server_dbus_arg_info_get_key_key, NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_get_key_out[] = {&_login_dhelper_server_dbus_arg_info_get_key_result, NULL};
static const GDBusMethodInfo _login_dhelper_server_dbus_method_info_get_key = {-1, "GetKey", (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_get_key_in), (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_get_key_out), NULL};
static const GDBusArgInfo _login_dhelper_server_dbus_arg_info_get_config_file_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_get_config_file_in[] = {NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_get_config_file_out[] = {&_login_dhelper_server_dbus_arg_info_get_config_file_result, NULL};
static const GDBusMethodInfo _login_dhelper_server_dbus_method_info_get_config_file = {-1, "GetConfigFile", (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_get_config_file_in), (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_get_config_file_out), NULL};
static const GDBusMethodInfo * const _login_dhelper_server_dbus_method_info[] = {&_login_dhelper_server_dbus_method_info_set_key, &_login_dhelper_server_dbus_method_info_get_key, &_login_dhelper_server_dbus_method_info_get_config_file, NULL};
static const GDBusArgInfo * const _login_dhelper_server_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _login_dhelper_server_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_login_dhelper_server_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _login_dhelper_server_dbus_signal_info[] = {&_login_dhelper_server_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo _login_dhelper_server_dbus_property_info_present = {-1, "Present", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _login_dhelper_server_dbus_property_info[] = {&_login_dhelper_server_dbus_property_info_present, NULL};
static const GDBusInterfaceInfo _login_dhelper_server_dbus_interface_info = {-1, "io.elementary.logind.helper", (GDBusMethodInfo **) (&_login_dhelper_server_dbus_method_info), (GDBusSignalInfo **) (&_login_dhelper_server_dbus_signal_info), (GDBusPropertyInfo **) (&_login_dhelper_server_dbus_property_info), NULL};
static const GDBusInterfaceVTable _login_dhelper_server_dbus_interface_vtable = {login_dhelper_server_dbus_interface_method_call, login_dhelper_server_dbus_interface_get_property, login_dhelper_server_dbus_interface_set_property};

static inline gpointer
login_dhelper_server_get_instance_private (LoginDHelperServer* self)
{
	return G_STRUCT_MEMBER_P (self, LoginDHelperServer_private_offset);
}

LoginDHelperServer*
login_dhelper_server_get_default (void)
{
	LoginDHelperServer* _tmp0_;
	LoginDHelperServer* _tmp2_;
	LoginDHelperServer* result;
#line 51 "../cli/Server.vala"
	_tmp0_ = login_dhelper_server_instance;
#line 51 "../cli/Server.vala"
	if (_tmp0_ == NULL) {
#line 235 "Server.c"
		LoginDHelperServer* _tmp1_;
#line 52 "../cli/Server.vala"
		_tmp1_ = login_dhelper_server_new ();
#line 52 "../cli/Server.vala"
		_g_object_unref0 (login_dhelper_server_instance);
#line 52 "../cli/Server.vala"
		login_dhelper_server_instance = _tmp1_;
#line 243 "Server.c"
	}
#line 55 "../cli/Server.vala"
	_tmp2_ = login_dhelper_server_instance;
#line 55 "../cli/Server.vala"
	result = _tmp2_;
#line 55 "../cli/Server.vala"
	return result;
#line 251 "Server.c"
}

/**
     * set_key:
     * @key: the key to set
     * @value: the value that key will be set with
     *
     * Sets the @key to @value in the logind config file (that is /etc/systemd/logind.conf)
     *
     * In order for this method to succeed, the caller must be already granted the 
     * io.elementary.settings.power.administration policy PolicyKit permission, otherwise
     * the method will throw an error and exit
     *
     * When the @key was successfully set, the changed () signal will be emitted
     */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 103 "../cli/Server.vala"
	return self ? g_error_copy (self) : NULL;
#line 272 "Server.c"
}

void
login_dhelper_server_set_key (LoginDHelperServer* self,
                              const gchar* key,
                              const gchar* value,
                              const char* sender,
                              GError** error)
{
	GKeyFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 90 "../cli/Server.vala"
	g_return_if_fail (self != NULL);
#line 90 "../cli/Server.vala"
	g_return_if_fail (key != NULL);
#line 90 "../cli/Server.vala"
	g_return_if_fail (value != NULL);
#line 90 "../cli/Server.vala"
	g_return_if_fail (sender != NULL);
#line 91 "../cli/Server.vala"
	g_signal_emit (self, login_dhelper_server_signals[LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL], 0);
#line 93 "../cli/Server.vala"
	if (!login_dhelper_server_get_sender_is_authorized (sender)) {
#line 296 "Server.c"
		GError* _tmp0_;
#line 94 "../cli/Server.vala"
		_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED, "Error: sender not authorized");
#line 94 "../cli/Server.vala"
		_inner_error0_ = _tmp0_;
#line 94 "../cli/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 94 "../cli/Server.vala"
		return;
#line 306 "Server.c"
	}
#line 97 "../cli/Server.vala"
	_tmp1_ = self->priv->file;
#line 97 "../cli/Server.vala"
	g_key_file_set_string (_tmp1_, LOGIN_DHELPER_SERVER_CONFIG_GROUP, key, value);
#line 312 "Server.c"
	{
		GKeyFile* _tmp2_;
#line 100 "../cli/Server.vala"
		_tmp2_ = self->priv->file;
#line 100 "../cli/Server.vala"
		g_key_file_save_to_file (_tmp2_, LOGIN_DHELPER_SERVER_CONFIG_FILE, &_inner_error0_);
#line 100 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "Server.c"
			goto __catch0_g_error;
		}
#line 101 "../cli/Server.vala"
		g_signal_emit (self, login_dhelper_server_signals[LOGIN_DHELPER_SERVER_CHANGED_SIGNAL], 0);
#line 326 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		GError* _tmp4_;
#line 99 "../cli/Server.vala"
		e = _inner_error0_;
#line 99 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 103 "../cli/Server.vala"
		_tmp3_ = e;
#line 103 "../cli/Server.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 103 "../cli/Server.vala"
		_inner_error0_ = _tmp4_;
#line 103 "../cli/Server.vala"
		_g_error_free0 (e);
#line 346 "Server.c"
		goto __finally0;
	}
	__finally0:
#line 99 "../cli/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../cli/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 99 "../cli/Server.vala"
		return;
#line 356 "Server.c"
	}
}

/**
     * get_key:
     * @key: the key to retrieve
     *
     * Returns the value of @key in the logind config file (that is /etc/systemd/logind.conf)
     *
     * If the @key does not exist, an error will be thrown
     *
     * Returns: the value for the @key
     */
gchar*
login_dhelper_server_get_key (LoginDHelperServer* self,
                              const gchar* key,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 117 "../cli/Server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../cli/Server.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 118 "../cli/Server.vala"
	g_signal_emit (self, login_dhelper_server_signals[LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL], 0);
#line 383 "Server.c"
	{
		gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 121 "../cli/Server.vala"
		_tmp1_ = self->priv->file;
#line 121 "../cli/Server.vala"
		_tmp2_ = g_key_file_get_string (_tmp1_, LOGIN_DHELPER_SERVER_CONFIG_GROUP, key, &_inner_error0_);
#line 121 "../cli/Server.vala"
		_tmp0_ = _tmp2_;
#line 121 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 397 "Server.c"
			goto __catch0_g_error;
		}
#line 121 "../cli/Server.vala"
		_tmp3_ = _tmp0_;
#line 121 "../cli/Server.vala"
		_tmp0_ = NULL;
#line 121 "../cli/Server.vala"
		result = _tmp3_;
#line 121 "../cli/Server.vala"
		_g_free0 (_tmp0_);
#line 121 "../cli/Server.vala"
		return result;
#line 410 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		GError* _tmp5_;
#line 120 "../cli/Server.vala"
		e = _inner_error0_;
#line 120 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 123 "../cli/Server.vala"
		_tmp4_ = e;
#line 123 "../cli/Server.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 123 "../cli/Server.vala"
		_inner_error0_ = _tmp5_;
#line 123 "../cli/Server.vala"
		_g_error_free0 (e);
#line 430 "Server.c"
		goto __finally0;
	}
	__finally0:
#line 120 "../cli/Server.vala"
	g_propagate_error (error, _inner_error0_);
#line 120 "../cli/Server.vala"
	return NULL;
#line 438 "Server.c"
}

/**
     * get_config_file:
     *
     * Gets a full path to the current used logind config file (at the moment this
     * will always return "/etc/systemd/logind.conf")
     */
gchar*
login_dhelper_server_get_config_file (LoginDHelperServer* self,
                                      GError** error)
{
	gchar* _tmp0_;
	gchar* result;
#line 133 "../cli/Server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../cli/Server.vala"
	g_signal_emit (self, login_dhelper_server_signals[LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL], 0);
#line 135 "../cli/Server.vala"
	_tmp0_ = g_strdup (LOGIN_DHELPER_SERVER_CONFIG_FILE);
#line 135 "../cli/Server.vala"
	result = _tmp0_;
#line 135 "../cli/Server.vala"
	return result;
#line 463 "Server.c"
}

static gboolean
login_dhelper_server_get_sender_is_authorized (const char* sender)
{
	PowerDBus* _tmp0_;
	guint32 user = 0U;
	guint32 pid = 0U;
	PolkitUnixProcess* subject = NULL;
	PolkitUnixProcess* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 138 "../cli/Server.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 139 "../cli/Server.vala"
	_tmp0_ = login_dhelper_server_bus_proxy;
#line 139 "../cli/Server.vala"
	if (_tmp0_ == NULL) {
#line 140 "../cli/Server.vala"
		result = FALSE;
#line 140 "../cli/Server.vala"
		return result;
#line 486 "Server.c"
	}
#line 143 "../cli/Server.vala"
	user = (guint32) 0;
#line 143 "../cli/Server.vala"
	pid = (guint32) 0;
#line 492 "Server.c"
	{
		guint32 _tmp1_ = 0U;
		PowerDBus* _tmp2_;
		guint32 _tmp3_ = 0U;
		PowerDBus* _tmp4_;
#line 146 "../cli/Server.vala"
		_tmp2_ = login_dhelper_server_bus_proxy;
#line 146 "../cli/Server.vala"
		_tmp1_ = power_dbus_get_connection_unix_process_id (_tmp2_, (const gchar*) sender, &_inner_error0_);
#line 146 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 504 "Server.c"
			goto __catch0_g_error;
		}
#line 146 "../cli/Server.vala"
		pid = _tmp1_;
#line 147 "../cli/Server.vala"
		_tmp4_ = login_dhelper_server_bus_proxy;
#line 147 "../cli/Server.vala"
		_tmp3_ = power_dbus_get_connection_unix_user (_tmp4_, (const gchar*) sender, &_inner_error0_);
#line 147 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "Server.c"
			goto __catch0_g_error;
		}
#line 147 "../cli/Server.vala"
		user = _tmp3_;
#line 520 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 145 "../cli/Server.vala"
		e = _inner_error0_;
#line 145 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 149 "../cli/Server.vala"
		_tmp5_ = e;
#line 149 "../cli/Server.vala"
		_tmp6_ = _tmp5_->message;
#line 149 "../cli/Server.vala"
		g_warning ("Server.vala:149: %s", _tmp6_);
#line 150 "../cli/Server.vala"
		result = FALSE;
#line 150 "../cli/Server.vala"
		_g_error_free0 (e);
#line 150 "../cli/Server.vala"
		return result;
#line 544 "Server.c"
	}
	__finally0:
#line 145 "../cli/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 549 "Server.c"
		gboolean _tmp7_ = FALSE;
#line 145 "../cli/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../cli/Server.vala"
		g_clear_error (&_inner_error0_);
#line 145 "../cli/Server.vala"
		return _tmp7_;
#line 557 "Server.c"
	}
#line 153 "../cli/Server.vala"
	_tmp8_ = (PolkitUnixProcess*) polkit_unix_process_new_for_owner ((gint) pid, (guint64) 0, (gint) user);
#line 153 "../cli/Server.vala"
	subject = _tmp8_;
#line 563 "Server.c"
	{
		PolkitAuthority* authority = NULL;
		PolkitAuthority* _tmp9_;
		PolkitAuthorizationResult* auth_result = NULL;
		PolkitAuthority* _tmp10_;
		PolkitUnixProcess* _tmp11_;
		PolkitAuthorizationResult* _tmp12_;
		PolkitAuthorizationResult* _tmp13_;
#line 156 "../cli/Server.vala"
		_tmp9_ = polkit_authority_get_sync (NULL, &_inner_error0_);
#line 156 "../cli/Server.vala"
		authority = _tmp9_;
#line 156 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 578 "Server.c"
			goto __catch1_g_error;
		}
#line 157 "../cli/Server.vala"
		_tmp10_ = authority;
#line 157 "../cli/Server.vala"
		_tmp11_ = subject;
#line 157 "../cli/Server.vala"
		_tmp12_ = polkit_authority_check_authorization_sync (_tmp10_, (PolkitSubject*) _tmp11_, LOGIN_DHELPER_SERVER_ACTION_ID, NULL, POLKIT_CHECK_AUTHORIZATION_FLAGS_NONE, NULL, &_inner_error0_);
#line 157 "../cli/Server.vala"
		auth_result = _tmp12_;
#line 157 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../cli/Server.vala"
			_g_object_unref0 (authority);
#line 593 "Server.c"
			goto __catch1_g_error;
		}
#line 163 "../cli/Server.vala"
		_tmp13_ = auth_result;
#line 163 "../cli/Server.vala"
		result = polkit_authorization_result_get_is_authorized (_tmp13_);
#line 163 "../cli/Server.vala"
		_g_object_unref0 (auth_result);
#line 163 "../cli/Server.vala"
		_g_object_unref0 (authority);
#line 163 "../cli/Server.vala"
		_g_object_unref0 (subject);
#line 163 "../cli/Server.vala"
		return result;
#line 608 "Server.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 155 "../cli/Server.vala"
		e = _inner_error0_;
#line 155 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 165 "../cli/Server.vala"
		_tmp14_ = e;
#line 165 "../cli/Server.vala"
		_tmp15_ = _tmp14_->message;
#line 165 "../cli/Server.vala"
		g_warning ("Server.vala:165: %s", _tmp15_);
#line 155 "../cli/Server.vala"
		_g_error_free0 (e);
#line 628 "Server.c"
	}
	__finally1:
#line 155 "../cli/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 633 "Server.c"
		gboolean _tmp16_ = FALSE;
#line 155 "../cli/Server.vala"
		_g_object_unref0 (subject);
#line 155 "../cli/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../cli/Server.vala"
		g_clear_error (&_inner_error0_);
#line 155 "../cli/Server.vala"
		return _tmp16_;
#line 643 "Server.c"
	}
#line 168 "../cli/Server.vala"
	result = FALSE;
#line 168 "../cli/Server.vala"
	_g_object_unref0 (subject);
#line 168 "../cli/Server.vala"
	return result;
#line 651 "Server.c"
}

LoginDHelperServer*
login_dhelper_server_construct (GType object_type)
{
	LoginDHelperServer * self = NULL;
#line 21 "../cli/Server.vala"
	self = (LoginDHelperServer*) g_object_new (object_type, NULL);
#line 21 "../cli/Server.vala"
	return self;
#line 662 "Server.c"
}

LoginDHelperServer*
login_dhelper_server_new (void)
{
#line 21 "../cli/Server.vala"
	return login_dhelper_server_construct (LOGIN_DHELPER_TYPE_SERVER);
#line 670 "Server.c"
}

gboolean
login_dhelper_server_get_present (LoginDHelperServer* self)
{
	gboolean result;
#line 40 "../cli/Server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../cli/Server.vala"
	g_signal_emit (self, login_dhelper_server_signals[LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL], 0);
#line 42 "../cli/Server.vala"
	result = self->priv->_present;
#line 42 "../cli/Server.vala"
	return result;
#line 685 "Server.c"
}

static GObject *
login_dhelper_server_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	LoginDHelperServer * self;
	GKeyFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 67 "../cli/Server.vala"
	parent_class = G_OBJECT_CLASS (login_dhelper_server_parent_class);
#line 67 "../cli/Server.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 67 "../cli/Server.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServer);
#line 68 "../cli/Server.vala"
	_tmp0_ = g_key_file_new ();
#line 68 "../cli/Server.vala"
	_g_key_file_unref0 (self->priv->file);
#line 68 "../cli/Server.vala"
	self->priv->file = _tmp0_;
#line 710 "Server.c"
	{
		gboolean _tmp1_ = FALSE;
		GKeyFile* _tmp2_;
#line 71 "../cli/Server.vala"
		_tmp2_ = self->priv->file;
#line 71 "../cli/Server.vala"
		_tmp1_ = g_key_file_load_from_file (_tmp2_, LOGIN_DHELPER_SERVER_CONFIG_FILE, G_KEY_FILE_KEEP_COMMENTS, &_inner_error0_);
#line 71 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 720 "Server.c"
			goto __catch0_g_error;
		}
#line 71 "../cli/Server.vala"
		self->priv->_present = _tmp1_;
#line 725 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 70 "../cli/Server.vala"
		e = _inner_error0_;
#line 70 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 73 "../cli/Server.vala"
		_tmp3_ = e;
#line 73 "../cli/Server.vala"
		_tmp4_ = _tmp3_->message;
#line 73 "../cli/Server.vala"
		g_warning ("Server.vala:73: %s", _tmp4_);
#line 70 "../cli/Server.vala"
		_g_error_free0 (e);
#line 745 "Server.c"
	}
	__finally0:
#line 70 "../cli/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../cli/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../cli/Server.vala"
		g_clear_error (&_inner_error0_);
#line 754 "Server.c"
	}
#line 67 "../cli/Server.vala"
	return obj;
#line 758 "Server.c"
}

static void
login_dhelper_server_class_init (LoginDHelperServerClass * klass,
                                 gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 21 "../cli/Server.vala"
	login_dhelper_server_parent_class = g_type_class_peek_parent (klass);
#line 21 "../cli/Server.vala"
	g_type_class_adjust_private_offset (klass, &LoginDHelperServer_private_offset);
#line 21 "../cli/Server.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_login_dhelper_server_get_property;
#line 21 "../cli/Server.vala"
	G_OBJECT_CLASS (klass)->constructor = login_dhelper_server_constructor;
#line 21 "../cli/Server.vala"
	G_OBJECT_CLASS (klass)->finalize = login_dhelper_server_finalize;
#line 21 "../cli/Server.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_DHELPER_SERVER_PRESENT_PROPERTY, login_dhelper_server_properties[LOGIN_DHELPER_SERVER_PRESENT_PROPERTY] = g_param_spec_boolean ("present", "present", "present", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../cli/Server.vala"
	login_dhelper_server_signals[LOGIN_DHELPER_SERVER_RESET_TIMEOUT_SIGNAL] = g_signal_new ("reset-timeout", LOGIN_DHELPER_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 780 "Server.c"
	/**
	     * changed:
	     *
	     * Emitted when a call to set_key () succeeded
	     */
#line 21 "../cli/Server.vala"
	login_dhelper_server_signals[LOGIN_DHELPER_SERVER_CHANGED_SIGNAL] = g_signal_new ("changed", LOGIN_DHELPER_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 788 "Server.c"
	{
		PowerDBus* _tmp0_ = NULL;
		PowerDBus* _tmp1_;
		PowerDBus* _tmp2_;
#line 60 "../cli/Server.vala"
		_tmp1_ = (PowerDBus*) g_initable_new (POWER_TYPE_DBUS_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.DBus", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/", "g-interface-name", "org.freedesktop.DBus", NULL);
#line 60 "../cli/Server.vala"
		_tmp0_ = (PowerDBus*) _tmp1_;
#line 60 "../cli/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 799 "Server.c"
			goto __catch0_g_error;
		}
#line 60 "../cli/Server.vala"
		_tmp2_ = _tmp0_;
#line 60 "../cli/Server.vala"
		_tmp0_ = NULL;
#line 60 "../cli/Server.vala"
		_g_object_unref0 (login_dhelper_server_bus_proxy);
#line 60 "../cli/Server.vala"
		login_dhelper_server_bus_proxy = _tmp2_;
#line 59 "../cli/Server.vala"
		_g_object_unref0 (_tmp0_);
#line 812 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 59 "../cli/Server.vala"
		e = _inner_error0_;
#line 59 "../cli/Server.vala"
		_inner_error0_ = NULL;
#line 62 "../cli/Server.vala"
		_tmp3_ = e;
#line 62 "../cli/Server.vala"
		_tmp4_ = _tmp3_->message;
#line 62 "../cli/Server.vala"
		g_warning ("Server.vala:62: %s", _tmp4_);
#line 63 "../cli/Server.vala"
		_g_object_unref0 (login_dhelper_server_bus_proxy);
#line 63 "../cli/Server.vala"
		login_dhelper_server_bus_proxy = NULL;
#line 59 "../cli/Server.vala"
		_g_error_free0 (e);
#line 836 "Server.c"
	}
	__finally0:
#line 59 "../cli/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../cli/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../cli/Server.vala"
		g_clear_error (&_inner_error0_);
#line 845 "Server.c"
	}
}

static void
login_dhelper_server_instance_init (LoginDHelperServer * self,
                                    gpointer klass)
{
#line 21 "../cli/Server.vala"
	self->priv = login_dhelper_server_get_instance_private (self);
#line 38 "../cli/Server.vala"
	self->priv->_present = FALSE;
#line 857 "Server.c"
}

static void
login_dhelper_server_finalize (GObject * obj)
{
	LoginDHelperServer * self;
#line 21 "../cli/Server.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServer);
#line 36 "../cli/Server.vala"
	_g_key_file_unref0 (self->priv->file);
#line 21 "../cli/Server.vala"
	G_OBJECT_CLASS (login_dhelper_server_parent_class)->finalize (obj);
#line 870 "Server.c"
}

static GType
login_dhelper_server_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LoginDHelperServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_dhelper_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LoginDHelperServer), 0, (GInstanceInitFunc) login_dhelper_server_instance_init, NULL };
	GType login_dhelper_server_type_id;
	login_dhelper_server_type_id = g_type_register_static (G_TYPE_OBJECT, "LoginDHelperServer", &g_define_type_info, 0);
	g_type_set_qdata (login_dhelper_server_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) login_dhelper_server_register_object);
	LoginDHelperServer_private_offset = g_type_add_instance_private (login_dhelper_server_type_id, sizeof (LoginDHelperServerPrivate));
	return login_dhelper_server_type_id;
}

GType
login_dhelper_server_get_type (void)
{
	static volatile gsize login_dhelper_server_type_id__once = 0;
	if (g_once_init_enter (&login_dhelper_server_type_id__once)) {
		GType login_dhelper_server_type_id;
		login_dhelper_server_type_id = login_dhelper_server_get_type_once ();
		g_once_init_leave (&login_dhelper_server_type_id__once, login_dhelper_server_type_id);
	}
	return login_dhelper_server_type_id__once;
}

static void
_vala_login_dhelper_server_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	LoginDHelperServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LOGIN_DHELPER_TYPE_SERVER, LoginDHelperServer);
#line 21 "../cli/Server.vala"
	switch (property_id) {
#line 21 "../cli/Server.vala"
		case LOGIN_DHELPER_SERVER_PRESENT_PROPERTY:
#line 21 "../cli/Server.vala"
		g_value_set_boolean (value, login_dhelper_server_get_present (self));
#line 21 "../cli/Server.vala"
		break;
#line 912 "Server.c"
		default:
#line 21 "../cli/Server.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../cli/Server.vala"
		break;
#line 918 "Server.c"
	}
}

static void
_dbus_login_dhelper_server_set_key (LoginDHelperServer* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* key = NULL;
	GVariant* _tmp0_;
	gchar* value = NULL;
	GVariant* _tmp1_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	key = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	value = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	login_dhelper_server_set_key (self, key, value, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (key);
	_g_free0 (value);
	;
}

static void
_dbus_login_dhelper_server_get_key (LoginDHelperServer* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* key = NULL;
	GVariant* _tmp2_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	key = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	result = login_dhelper_server_get_key (self, key, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (key);
	;
}

static void
_dbus_login_dhelper_server_get_config_file (LoginDHelperServer* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = login_dhelper_server_get_config_file (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
login_dhelper_server_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "SetKey") == 0) {
		_dbus_login_dhelper_server_set_key (object, parameters, invocation);
	} else if (strcmp (method_name, "GetKey") == 0) {
		_dbus_login_dhelper_server_get_key (object, parameters, invocation);
	} else if (strcmp (method_name, "GetConfigFile") == 0) {
		_dbus_login_dhelper_server_get_config_file (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_login_dhelper_server_get_present (LoginDHelperServer* self)
{
	gboolean result;
	GVariant* _reply;
	result = login_dhelper_server_get_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
login_dhelper_server_dbus_interface_get_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Present") == 0) {
		return _dbus_login_dhelper_server_get_present (object);
	}
	return NULL;
}

static gboolean
login_dhelper_server_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_login_dhelper_server_changed (GObject* _sender,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "io.elementary.logind.helper", "Changed", _arguments, NULL);
}

guint
login_dhelper_server_register_object (gpointer object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_login_dhelper_server_dbus_interface_info), &_login_dhelper_server_dbus_interface_vtable, data, _login_dhelper_server_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_login_dhelper_server_changed, data);
	return result;
}

static void
_login_dhelper_server_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_login_dhelper_server_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

