/* Device.c generated by valac 0.56.17, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 */

#include "power.h"
#include <glib.h>
#include <gio/gio.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

#define POWER_DEVICE_UPOWER_NAME "org.freedesktop.UPower"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_UPOWER_DEVICE_CHANGED_SIGNAL,
	POWER_UPOWER_DEVICE_NUM_SIGNALS
};
static guint power_upower_device_signals[POWER_UPOWER_DEVICE_NUM_SIGNALS] = {0};
typedef GDBusProxy PowerUpowerDeviceProxy;
typedef GDBusProxyClass PowerUpowerDeviceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	POWER_DEVICE_0_PROPERTY,
	POWER_DEVICE_PATH_PROPERTY,
	POWER_DEVICE_POWER_SUPPLY_PROPERTY,
	POWER_DEVICE_PERCENTAGE_PROPERTY,
	POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY,
	POWER_DEVICE_DESCRIPTION_PROPERTY,
	POWER_DEVICE_ICON_NAME_PROPERTY,
	POWER_DEVICE_MODEL_PROPERTY,
	POWER_DEVICE_STATE_PROPERTY,
	POWER_DEVICE_DEVICE_TYPE_PROPERTY,
	POWER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* power_device_properties[POWER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerDevicePrivate {
	gchar* _path;
	gboolean _power_supply;
	gdouble _percentage;
	gboolean _coarse_battery_level;
	gchar* _description;
	gchar* _icon_name;
	gchar* _model;
	PowerDeviceState _state;
	PowerDeviceType _device_type;
	PowerUpowerDevice* upower_device;
};

static gint PowerDevice_private_offset;
static gpointer power_device_parent_class = NULL;

static GType power_upower_device_get_type_once (void);
static void power_upower_device_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters);
static void _dbus_handle_power_upower_device_changed (PowerUpowerDevice* self,
                                               GVariant* parameters);
static void power_upower_device_proxy_refresh (PowerUpowerDevice* self,
                                        GError** error);
static gboolean power_upower_device_dbus_proxy_get_is_present (PowerUpowerDevice* self);
static gboolean power_upower_device_dbus_proxy_get_online (PowerUpowerDevice* self);
static gboolean power_upower_device_dbus_proxy_get_power_supply (PowerUpowerDevice* self);
static gdouble power_upower_device_dbus_proxy_get_percentage (PowerUpowerDevice* self);
static gchar* power_upower_device_dbus_proxy_get_model (PowerUpowerDevice* self);
static guint32 power_upower_device_dbus_proxy_get_battery_level (PowerUpowerDevice* self);
static PowerDeviceState power_upower_device_dbus_proxy_get_state (PowerUpowerDevice* self);
static PowerDeviceType power_upower_device_dbus_proxy_get_device_type (PowerUpowerDevice* self);
static void power_upower_device_proxy_power_upower_device_interface_init (PowerUpowerDeviceIface* iface);
static void _dbus_power_upower_device_refresh (PowerUpowerDevice* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation);
static void power_upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data);
static GVariant* power_upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GError** error,
                                                           gpointer user_data);
static GVariant* _dbus_power_upower_device_get_is_present (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_online (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_power_supply (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_percentage (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_model (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_battery_level (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_state (PowerUpowerDevice* self);
static GVariant* _dbus_power_upower_device_get_device_type (PowerUpowerDevice* self);
static gboolean power_upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data);
static void _dbus_power_upower_device_changed (GObject* _sender,
                                        gpointer* _data);
static void _power_upower_device_unregister_object (gpointer user_data);
static void power_device_update_properties (PowerDevice* self);
static void power_device_set_coarse_battery_level (PowerDevice* self,
                                            gboolean value);
static void power_device_set_model (PowerDevice* self,
                             const gchar* value);
static void power_device_set_percentage (PowerDevice* self,
                                  gdouble value);
static void power_device_set_state (PowerDevice* self,
                             PowerDeviceState value);
static void power_device_set_icon_name (PowerDevice* self,
                                 const gchar* value);
static void power_device_update_description (PowerDevice* self);
static void power_device_set_description (PowerDevice* self,
                                   const gchar* value);
static void power_device_set_power_supply (PowerDevice* self,
                                    gboolean value);
static void power_device_set_device_type (PowerDevice* self,
                                   PowerDeviceType value);
static GObject * power_device_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _power_device_update_properties_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                        GVariant* changed_properties,
                                                                        gchar** invalidated_properties,
                                                                        gpointer self);
static void _power_device_update_description_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void power_device_finalize (GObject * obj);
static GType power_device_get_type_once (void);
static void _vala_power_device_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_power_device_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static const GDBusArgInfo * const _power_upower_device_dbus_arg_info_refresh_in[] = {NULL};
static const GDBusArgInfo * const _power_upower_device_dbus_arg_info_refresh_out[] = {NULL};
static const GDBusMethodInfo _power_upower_device_dbus_method_info_refresh = {-1, "Refresh", (GDBusArgInfo **) (&_power_upower_device_dbus_arg_info_refresh_in), (GDBusArgInfo **) (&_power_upower_device_dbus_arg_info_refresh_out), NULL};
static const GDBusMethodInfo * const _power_upower_device_dbus_method_info[] = {&_power_upower_device_dbus_method_info_refresh, NULL};
static const GDBusArgInfo * const _power_upower_device_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _power_upower_device_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_power_upower_device_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _power_upower_device_dbus_signal_info[] = {&_power_upower_device_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_is_present = {-1, "IsPresent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_online = {-1, "Online", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_power_supply = {-1, "PowerSupply", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_percentage = {-1, "Percentage", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_model = {-1, "Model", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_battery_level = {-1, "BatteryLevel", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_state = {-1, "State", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _power_upower_device_dbus_property_info_device_type = {-1, "Type", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _power_upower_device_dbus_property_info[] = {&_power_upower_device_dbus_property_info_is_present, &_power_upower_device_dbus_property_info_online, &_power_upower_device_dbus_property_info_power_supply, &_power_upower_device_dbus_property_info_percentage, &_power_upower_device_dbus_property_info_model, &_power_upower_device_dbus_property_info_battery_level, &_power_upower_device_dbus_property_info_state, &_power_upower_device_dbus_property_info_device_type, NULL};
static const GDBusInterfaceInfo _power_upower_device_dbus_interface_info = {-1, "org.freedesktop.UPower.Device", (GDBusMethodInfo **) (&_power_upower_device_dbus_method_info), (GDBusSignalInfo **) (&_power_upower_device_dbus_signal_info), (GDBusPropertyInfo **) (&_power_upower_device_dbus_property_info), NULL};
static const GDBusInterfaceVTable _power_upower_device_dbus_interface_vtable = {power_upower_device_dbus_interface_method_call, power_upower_device_dbus_interface_get_property, power_upower_device_dbus_interface_set_property};

void
power_upower_device_refresh (PowerUpowerDevice* self,
                             GError** error)
{
	PowerUpowerDeviceIface* _iface_;
#line 15 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 15 "../src/Device.vala"
	if (_iface_->refresh) {
#line 15 "../src/Device.vala"
		_iface_->refresh (self, error);
#line 197 "Device.c"
	}
}

gboolean
power_upower_device_get_is_present (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 9 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 9 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 9 "../src/Device.vala"
	if (_iface_->get_is_present) {
#line 9 "../src/Device.vala"
		return _iface_->get_is_present (self);
#line 213 "Device.c"
	}
#line 9 "../src/Device.vala"
	return FALSE;
#line 217 "Device.c"
}

gboolean
power_upower_device_get_online (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 10 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 10 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 10 "../src/Device.vala"
	if (_iface_->get_online) {
#line 10 "../src/Device.vala"
		return _iface_->get_online (self);
#line 232 "Device.c"
	}
#line 10 "../src/Device.vala"
	return FALSE;
#line 236 "Device.c"
}

gboolean
power_upower_device_get_power_supply (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 11 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 11 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 11 "../src/Device.vala"
	if (_iface_->get_power_supply) {
#line 11 "../src/Device.vala"
		return _iface_->get_power_supply (self);
#line 251 "Device.c"
	}
#line 11 "../src/Device.vala"
	return FALSE;
#line 255 "Device.c"
}

gdouble
power_upower_device_get_percentage (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 12 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 12 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 12 "../src/Device.vala"
	if (_iface_->get_percentage) {
#line 12 "../src/Device.vala"
		return _iface_->get_percentage (self);
#line 270 "Device.c"
	}
#line 12 "../src/Device.vala"
	return -1.0;
#line 274 "Device.c"
}

gchar*
power_upower_device_get_model (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 13 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 13 "../src/Device.vala"
	if (_iface_->get_model) {
#line 13 "../src/Device.vala"
		return _iface_->get_model (self);
#line 289 "Device.c"
	}
#line 13 "../src/Device.vala"
	return NULL;
#line 293 "Device.c"
}

guint32
power_upower_device_get_battery_level (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 14 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 14 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 14 "../src/Device.vala"
	if (_iface_->get_battery_level) {
#line 14 "../src/Device.vala"
		return _iface_->get_battery_level (self);
#line 308 "Device.c"
	}
#line 14 "../src/Device.vala"
	return 0U;
#line 312 "Device.c"
}

PowerDeviceState
power_upower_device_get_state (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 16 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 16 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 16 "../src/Device.vala"
	if (_iface_->get_state) {
#line 16 "../src/Device.vala"
		return _iface_->get_state (self);
#line 327 "Device.c"
	}
#line 16 "../src/Device.vala"
	return 0;
#line 331 "Device.c"
}

PowerDeviceType
power_upower_device_get_device_type (PowerUpowerDevice* self)
{
	PowerUpowerDeviceIface* _iface_;
#line 18 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18 "../src/Device.vala"
	_iface_ = POWER_UPOWER_DEVICE_GET_INTERFACE (self);
#line 18 "../src/Device.vala"
	if (_iface_->get_device_type) {
#line 18 "../src/Device.vala"
		return _iface_->get_device_type (self);
#line 346 "Device.c"
	}
#line 18 "../src/Device.vala"
	return 0;
#line 350 "Device.c"
}

static void
power_upower_device_default_init (PowerUpowerDeviceIface * iface,
                                  gpointer iface_data)
{
#line 7 "../src/Device.vala"
	power_upower_device_signals[POWER_UPOWER_DEVICE_CHANGED_SIGNAL] = g_signal_new ("changed", POWER_TYPE_UPOWER_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 359 "Device.c"
}

static GType
power_upower_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerUpowerDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_upower_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType power_upower_device_type_id;
	power_upower_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "PowerUpowerDevice", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (power_upower_device_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (power_upower_device_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) power_upower_device_proxy_get_type);
	g_type_set_qdata (power_upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower.Device");
	g_type_set_qdata (power_upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_power_upower_device_dbus_interface_info));
	g_type_set_qdata (power_upower_device_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) power_upower_device_register_object);
	return power_upower_device_type_id;
}

GType
power_upower_device_get_type (void)
{
	static volatile gsize power_upower_device_type_id__once = 0;
	if (g_once_init_enter (&power_upower_device_type_id__once)) {
		GType power_upower_device_type_id;
		power_upower_device_type_id = power_upower_device_get_type_once ();
		g_once_init_leave (&power_upower_device_type_id__once, power_upower_device_type_id);
	}
	return power_upower_device_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (PowerUpowerDeviceProxy, power_upower_device_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (POWER_TYPE_UPOWER_DEVICE, power_upower_device_proxy_power_upower_device_interface_init) )
static void
power_upower_device_proxy_class_init (PowerUpowerDeviceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = power_upower_device_proxy_g_signal;
}

static void
_dbus_handle_power_upower_device_changed (PowerUpowerDevice* self,
                                          GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}

static void
power_upower_device_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters)
{
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_power_upower_device_changed ((PowerUpowerDevice*) proxy, parameters);
	}
}

static void
power_upower_device_proxy_init (PowerUpowerDeviceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_power_upower_device_dbus_interface_info));
}

static void
power_upower_device_proxy_refresh (PowerUpowerDevice* self,
                                   GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.UPower.Device", "Refresh");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gboolean
power_upower_device_dbus_proxy_get_is_present (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "IsPresent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("IsPresent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp0_ = FALSE;
			return _tmp0_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
power_upower_device_dbus_proxy_get_online (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Online");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Online"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp1_ = FALSE;
			return _tmp1_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
power_upower_device_dbus_proxy_get_power_supply (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PowerSupply");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSupply"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp2_ = FALSE;
			return _tmp2_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
power_upower_device_dbus_proxy_get_percentage (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Percentage");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Percentage"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp3_ = 0.0;
			return _tmp3_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
power_upower_device_dbus_proxy_get_model (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Model");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Model"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static guint32
power_upower_device_dbus_proxy_get_battery_level (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	guint32 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "BatteryLevel");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("BatteryLevel"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint32 _tmp4_ = 0U;
			return _tmp4_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static PowerDeviceState
power_upower_device_dbus_proxy_get_state (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	PowerDeviceState _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "State");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("State"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static PowerDeviceType
power_upower_device_dbus_proxy_get_device_type (PowerUpowerDevice* self)
{
	GVariant *_inner_reply;
	PowerDeviceType _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Type");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Type"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
power_upower_device_proxy_power_upower_device_interface_init (PowerUpowerDeviceIface* iface)
{
	iface->refresh = power_upower_device_proxy_refresh;
	iface->get_is_present = power_upower_device_dbus_proxy_get_is_present;
	iface->get_online = power_upower_device_dbus_proxy_get_online;
	iface->get_power_supply = power_upower_device_dbus_proxy_get_power_supply;
	iface->get_percentage = power_upower_device_dbus_proxy_get_percentage;
	iface->get_model = power_upower_device_dbus_proxy_get_model;
	iface->get_battery_level = power_upower_device_dbus_proxy_get_battery_level;
	iface->get_state = power_upower_device_dbus_proxy_get_state;
	iface->get_device_type = power_upower_device_dbus_proxy_get_device_type;
}

static void
_dbus_power_upower_device_refresh (PowerUpowerDevice* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	power_upower_device_refresh (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
power_upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Refresh") == 0) {
		_dbus_power_upower_device_refresh (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_power_upower_device_get_is_present (PowerUpowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = power_upower_device_get_is_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_online (PowerUpowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = power_upower_device_get_online (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_power_supply (PowerUpowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = power_upower_device_get_power_supply (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_percentage (PowerUpowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = power_upower_device_get_percentage (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_model (PowerUpowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = power_upower_device_get_model (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_battery_level (PowerUpowerDevice* self)
{
	guint32 result;
	GVariant* _reply;
	result = power_upower_device_get_battery_level (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_state (PowerUpowerDevice* self)
{
	PowerDeviceState result;
	GVariant* _reply;
	result = power_upower_device_get_state (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_power_upower_device_get_device_type (PowerUpowerDevice* self)
{
	PowerDeviceType result;
	GVariant* _reply;
	result = power_upower_device_get_device_type (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
power_upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "IsPresent") == 0) {
		return _dbus_power_upower_device_get_is_present (object);
	} else if (strcmp (property_name, "Online") == 0) {
		return _dbus_power_upower_device_get_online (object);
	} else if (strcmp (property_name, "PowerSupply") == 0) {
		return _dbus_power_upower_device_get_power_supply (object);
	} else if (strcmp (property_name, "Percentage") == 0) {
		return _dbus_power_upower_device_get_percentage (object);
	} else if (strcmp (property_name, "Model") == 0) {
		return _dbus_power_upower_device_get_model (object);
	} else if (strcmp (property_name, "BatteryLevel") == 0) {
		return _dbus_power_upower_device_get_battery_level (object);
	} else if (strcmp (property_name, "State") == 0) {
		return _dbus_power_upower_device_get_state (object);
	} else if (strcmp (property_name, "Type") == 0) {
		return _dbus_power_upower_device_get_device_type (object);
	}
	return NULL;
}

static gboolean
power_upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GVariant* value,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_power_upower_device_changed (GObject* _sender,
                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower.Device", "Changed", _arguments, NULL);
}

guint
power_upower_device_register_object (gpointer object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_power_upower_device_dbus_interface_info), &_power_upower_device_dbus_interface_vtable, data, _power_upower_device_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_power_upower_device_changed, data);
	return result;
}

static void
_power_upower_device_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_power_upower_device_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
power_device_get_instance_private (PowerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, PowerDevice_private_offset);
}

GIcon*
power_device_state_to_icon (PowerDeviceState self)
{
	GIcon* result;
#line 35 "../src/Device.vala"
	switch (self) {
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_CHARGING:
#line 910 "Device.c"
		{
			GThemedIcon* _tmp0_;
#line 37 "../src/Device.vala"
			_tmp0_ = (GThemedIcon*) g_themed_icon_new ("device-charging-symbolic");
#line 37 "../src/Device.vala"
			result = (GIcon*) _tmp0_;
#line 37 "../src/Device.vala"
			return result;
#line 919 "Device.c"
		}
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_PENDING_CHARGE:
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_PENDING_DISCHARGE:
#line 925 "Device.c"
		{
			GThemedIcon* _tmp1_;
#line 40 "../src/Device.vala"
			_tmp1_ = (GThemedIcon*) g_themed_icon_new ("device-charging-paused-symbolic");
#line 40 "../src/Device.vala"
			result = (GIcon*) _tmp1_;
#line 40 "../src/Device.vala"
			return result;
#line 934 "Device.c"
		}
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_EMPTY:
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_UNKNOWN:
#line 940 "Device.c"
		{
			GThemedIcon* _tmp2_;
#line 43 "../src/Device.vala"
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning-symbolic");
#line 43 "../src/Device.vala"
			result = (GIcon*) _tmp2_;
#line 43 "../src/Device.vala"
			return result;
#line 949 "Device.c"
		}
		default:
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_DISCHARGING:
#line 35 "../src/Device.vala"
		case POWER_DEVICE_STATE_FULLY_CHARGED:
#line 956 "Device.c"
		{
#line 47 "../src/Device.vala"
			result = NULL;
#line 47 "../src/Device.vala"
			return result;
#line 962 "Device.c"
		}
	}
}

gchar*
power_device_state_to_string (PowerDeviceState self)
{
	gchar* result;
#line 52 "../src/Device.vala"
	switch (self) {
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_CHARGING:
#line 975 "Device.c"
		{
			gchar* _tmp0_;
#line 54 "../src/Device.vala"
			_tmp0_ = g_strdup (_ ("Charging"));
#line 54 "../src/Device.vala"
			result = _tmp0_;
#line 54 "../src/Device.vala"
			return result;
#line 984 "Device.c"
		}
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_DISCHARGING:
#line 988 "Device.c"
		{
			gchar* _tmp1_;
#line 56 "../src/Device.vala"
			_tmp1_ = g_strdup (_ ("Using battery power"));
#line 56 "../src/Device.vala"
			result = _tmp1_;
#line 56 "../src/Device.vala"
			return result;
#line 997 "Device.c"
		}
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_EMPTY:
#line 1001 "Device.c"
		{
			gchar* _tmp2_;
#line 58 "../src/Device.vala"
			_tmp2_ = g_strdup (_ ("Empty"));
#line 58 "../src/Device.vala"
			result = _tmp2_;
#line 58 "../src/Device.vala"
			return result;
#line 1010 "Device.c"
		}
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_FULLY_CHARGED:
#line 1014 "Device.c"
		{
			gchar* _tmp3_;
#line 60 "../src/Device.vala"
			_tmp3_ = g_strdup (_ ("Fully charged"));
#line 60 "../src/Device.vala"
			result = _tmp3_;
#line 60 "../src/Device.vala"
			return result;
#line 1023 "Device.c"
		}
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_PENDING_CHARGE:
#line 1027 "Device.c"
		{
			gchar* _tmp4_;
#line 62 "../src/Device.vala"
			_tmp4_ = g_strdup (_ ("Waiting to charge"));
#line 62 "../src/Device.vala"
			result = _tmp4_;
#line 62 "../src/Device.vala"
			return result;
#line 1036 "Device.c"
		}
#line 52 "../src/Device.vala"
		case POWER_DEVICE_STATE_PENDING_DISCHARGE:
#line 1040 "Device.c"
		{
			gchar* _tmp5_;
#line 64 "../src/Device.vala"
			_tmp5_ = g_strdup (_ ("Waiting to use battery power"));
#line 64 "../src/Device.vala"
			result = _tmp5_;
#line 64 "../src/Device.vala"
			return result;
#line 1049 "Device.c"
		}
		default:
		{
			gchar* _tmp6_;
#line 66 "../src/Device.vala"
			_tmp6_ = g_strdup (_ ("Unknown"));
#line 66 "../src/Device.vala"
			result = _tmp6_;
#line 66 "../src/Device.vala"
			return result;
#line 1060 "Device.c"
		}
	}
}

static GType
power_device_state_get_type_once (void)
{
	static const GEnumValue values[] = {{POWER_DEVICE_STATE_UNKNOWN, "POWER_DEVICE_STATE_UNKNOWN", "unknown"}, {POWER_DEVICE_STATE_CHARGING, "POWER_DEVICE_STATE_CHARGING", "charging"}, {POWER_DEVICE_STATE_DISCHARGING, "POWER_DEVICE_STATE_DISCHARGING", "discharging"}, {POWER_DEVICE_STATE_EMPTY, "POWER_DEVICE_STATE_EMPTY", "empty"}, {POWER_DEVICE_STATE_FULLY_CHARGED, "POWER_DEVICE_STATE_FULLY_CHARGED", "fully-charged"}, {POWER_DEVICE_STATE_PENDING_CHARGE, "POWER_DEVICE_STATE_PENDING_CHARGE", "pending-charge"}, {POWER_DEVICE_STATE_PENDING_DISCHARGE, "POWER_DEVICE_STATE_PENDING_DISCHARGE", "pending-discharge"}, {0, NULL, NULL}};
	GType power_device_state_type_id;
	power_device_state_type_id = g_enum_register_static ("PowerDeviceState", values);
	return power_device_state_type_id;
}

GType
power_device_state_get_type (void)
{
	static volatile gsize power_device_state_type_id__once = 0;
	if (g_once_init_enter (&power_device_state_type_id__once)) {
		GType power_device_state_type_id;
		power_device_state_type_id = power_device_state_get_type_once ();
		g_once_init_leave (&power_device_state_type_id__once, power_device_state_type_id);
	}
	return power_device_state_type_id__once;
}

static GType
power_device_type_get_type_once (void)
{
	static const GEnumValue values[] = {{POWER_DEVICE_TYPE_UNKNOWN, "POWER_DEVICE_TYPE_UNKNOWN", "unknown"}, {POWER_DEVICE_TYPE_LINE_POWER, "POWER_DEVICE_TYPE_LINE_POWER", "line-power"}, {POWER_DEVICE_TYPE_BATTERY, "POWER_DEVICE_TYPE_BATTERY", "battery"}, {POWER_DEVICE_TYPE_UPS, "POWER_DEVICE_TYPE_UPS", "ups"}, {POWER_DEVICE_TYPE_MONITOR, "POWER_DEVICE_TYPE_MONITOR", "monitor"}, {POWER_DEVICE_TYPE_MOUSE, "POWER_DEVICE_TYPE_MOUSE", "mouse"}, {POWER_DEVICE_TYPE_KEYBOARD, "POWER_DEVICE_TYPE_KEYBOARD", "keyboard"}, {POWER_DEVICE_TYPE_PDA, "POWER_DEVICE_TYPE_PDA", "pda"}, {POWER_DEVICE_TYPE_PHONE, "POWER_DEVICE_TYPE_PHONE", "phone"}, {POWER_DEVICE_TYPE_MEDIA_PLAYER, "POWER_DEVICE_TYPE_MEDIA_PLAYER", "media-player"}, {POWER_DEVICE_TYPE_TABLET, "POWER_DEVICE_TYPE_TABLET", "tablet"}, {POWER_DEVICE_TYPE_COMPUTER, "POWER_DEVICE_TYPE_COMPUTER", "computer"}, {POWER_DEVICE_TYPE_GAMING_INPUT, "POWER_DEVICE_TYPE_GAMING_INPUT", "gaming-input"}, {POWER_DEVICE_TYPE_PEN, "POWER_DEVICE_TYPE_PEN", "pen"}, {0, NULL, NULL}};
	GType power_device_type_type_id;
	power_device_type_type_id = g_enum_register_static ("PowerDeviceType", values);
	return power_device_type_type_id;
}

GType
power_device_type_get_type (void)
{
	static volatile gsize power_device_type_type_id__once = 0;
	if (g_once_init_enter (&power_device_type_type_id__once)) {
		GType power_device_type_type_id;
		power_device_type_type_id = power_device_type_get_type_once ();
		g_once_init_leave (&power_device_type_type_id__once, power_device_type_type_id);
	}
	return power_device_type_type_id__once;
}

PowerDevice*
power_device_construct (GType object_type,
                        const gchar* path)
{
	PowerDevice * self = NULL;
#line 110 "../src/Device.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 111 "../src/Device.vala"
	self = (PowerDevice*) g_object_new (object_type, "path", path, NULL);
#line 110 "../src/Device.vala"
	return self;
#line 1118 "Device.c"
}

PowerDevice*
power_device_new (const gchar* path)
{
#line 110 "../src/Device.vala"
	return power_device_construct (POWER_TYPE_DEVICE, path);
#line 1126 "Device.c"
}

static void
power_device_update_properties (PowerDevice* self)
{
	PowerUpowerDevice* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
	PowerUpowerDevice* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	PowerUpowerDevice* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	PowerUpowerDevice* _tmp10_;
	PowerDeviceState _tmp11_;
	PowerDeviceState _tmp12_;
	PowerDeviceType _tmp13_;
#line 136 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Device.vala"
	_tmp0_ = self->priv->upower_device;
#line 137 "../src/Device.vala"
	_tmp1_ = power_upower_device_get_battery_level (_tmp0_);
#line 137 "../src/Device.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/Device.vala"
	power_device_set_coarse_battery_level (self, _tmp2_ != ((guint32) 1));
#line 139 "../src/Device.vala"
	_tmp3_ = self->priv->upower_device;
#line 139 "../src/Device.vala"
	_tmp4_ = power_upower_device_get_model (_tmp3_);
#line 139 "../src/Device.vala"
	_tmp5_ = _tmp4_;
#line 139 "../src/Device.vala"
	_tmp6_ = _tmp5_;
#line 139 "../src/Device.vala"
	power_device_set_model (self, _tmp6_);
#line 139 "../src/Device.vala"
	_g_free0 (_tmp6_);
#line 140 "../src/Device.vala"
	_tmp7_ = self->priv->upower_device;
#line 140 "../src/Device.vala"
	_tmp8_ = power_upower_device_get_percentage (_tmp7_);
#line 140 "../src/Device.vala"
	_tmp9_ = _tmp8_;
#line 140 "../src/Device.vala"
	power_device_set_percentage (self, _tmp9_);
#line 141 "../src/Device.vala"
	_tmp10_ = self->priv->upower_device;
#line 141 "../src/Device.vala"
	_tmp11_ = power_upower_device_get_state (_tmp10_);
#line 141 "../src/Device.vala"
	_tmp12_ = _tmp11_;
#line 141 "../src/Device.vala"
	power_device_set_state (self, _tmp12_);
#line 143 "../src/Device.vala"
	_tmp13_ = self->priv->_device_type;
#line 143 "../src/Device.vala"
	switch (_tmp13_) {
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_UPS:
#line 1190 "Device.c"
		{
#line 145 "../src/Device.vala"
			power_device_set_icon_name (self, "uninterruptible-power-supply");
#line 146 "../src/Device.vala"
			break;
#line 1196 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_MOUSE:
#line 1200 "Device.c"
		{
#line 148 "../src/Device.vala"
			power_device_set_icon_name (self, "input-mouse");
#line 149 "../src/Device.vala"
			break;
#line 1206 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_KEYBOARD:
#line 1210 "Device.c"
		{
#line 151 "../src/Device.vala"
			power_device_set_icon_name (self, "input-keyboard");
#line 152 "../src/Device.vala"
			break;
#line 1216 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_PDA:
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_PHONE:
#line 1222 "Device.c"
		{
#line 155 "../src/Device.vala"
			power_device_set_icon_name (self, "phone");
#line 156 "../src/Device.vala"
			break;
#line 1228 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_MEDIA_PLAYER:
#line 1232 "Device.c"
		{
#line 158 "../src/Device.vala"
			power_device_set_icon_name (self, "multimedia-player");
#line 159 "../src/Device.vala"
			break;
#line 1238 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_TABLET:
#line 1242 "Device.c"
		{
#line 161 "../src/Device.vala"
			power_device_set_icon_name (self, "input-touchpad");
#line 162 "../src/Device.vala"
			break;
#line 1248 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_PEN:
#line 1252 "Device.c"
		{
#line 164 "../src/Device.vala"
			power_device_set_icon_name (self, "input-tablet");
#line 165 "../src/Device.vala"
			break;
#line 1258 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_GAMING_INPUT:
#line 1262 "Device.c"
		{
#line 167 "../src/Device.vala"
			power_device_set_icon_name (self, "input-gaming");
#line 168 "../src/Device.vala"
			break;
#line 1268 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_COMPUTER:
#line 1272 "Device.c"
		{
			const gchar* _tmp14_;
#line 170 "../src/Device.vala"
			_tmp14_ = self->priv->_model;
#line 170 "../src/Device.vala"
			if (g_strcmp0 (_tmp14_, "iPad") == 0) {
#line 171 "../src/Device.vala"
				power_device_set_icon_name (self, "computer-tablet");
#line 1281 "Device.c"
			} else {
#line 173 "../src/Device.vala"
				power_device_set_icon_name (self, "computer-laptop");
#line 1285 "Device.c"
			}
#line 176 "../src/Device.vala"
			break;
#line 1289 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_MONITOR:
#line 1293 "Device.c"
		{
#line 178 "../src/Device.vala"
			power_device_set_icon_name (self, "video-display");
#line 179 "../src/Device.vala"
			break;
#line 1299 "Device.c"
		}
#line 143 "../src/Device.vala"
		case POWER_DEVICE_TYPE_LINE_POWER:
#line 1303 "Device.c"
		{
#line 181 "../src/Device.vala"
			power_device_set_icon_name (self, "battery-ac-adapter");
#line 182 "../src/Device.vala"
			break;
#line 1309 "Device.c"
		}
		default:
		{
#line 184 "../src/Device.vala"
			power_device_set_icon_name (self, "battery");
#line 185 "../src/Device.vala"
			break;
#line 1317 "Device.c"
		}
	}
}

static void
power_device_update_description (PowerDevice* self)
{
	gboolean _tmp0_;
#line 189 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/Device.vala"
	_tmp0_ = self->priv->_coarse_battery_level;
#line 190 "../src/Device.vala"
	if (_tmp0_) {
#line 1332 "Device.c"
		gdouble _tmp1_;
#line 192 "../src/Device.vala"
		_tmp1_ = self->priv->_percentage;
#line 192 "../src/Device.vala"
		if (_tmp1_ < ((gdouble) 20)) {
#line 193 "../src/Device.vala"
			power_device_set_description (self, C_ ("battery-level", "Critical"));
#line 1340 "Device.c"
		} else {
			gdouble _tmp2_;
#line 194 "../src/Device.vala"
			_tmp2_ = self->priv->_percentage;
#line 194 "../src/Device.vala"
			if (_tmp2_ < ((gdouble) 40)) {
#line 195 "../src/Device.vala"
				power_device_set_description (self, C_ ("battery-level", "Low"));
#line 1349 "Device.c"
			} else {
				gdouble _tmp3_;
#line 196 "../src/Device.vala"
				_tmp3_ = self->priv->_percentage;
#line 196 "../src/Device.vala"
				if (_tmp3_ < ((gdouble) 60)) {
#line 197 "../src/Device.vala"
					power_device_set_description (self, C_ ("battery-level", "Good"));
#line 1358 "Device.c"
				} else {
					gdouble _tmp4_;
#line 198 "../src/Device.vala"
					_tmp4_ = self->priv->_percentage;
#line 198 "../src/Device.vala"
					if (_tmp4_ < ((gdouble) 80)) {
#line 199 "../src/Device.vala"
						power_device_set_description (self, C_ ("battery-level", "High"));
#line 1367 "Device.c"
					} else {
#line 201 "../src/Device.vala"
						power_device_set_description (self, C_ ("battery-level", "Full"));
#line 1371 "Device.c"
					}
				}
			}
		}
	} else {
		gboolean _tmp5_ = FALSE;
		gdouble _tmp6_;
#line 204 "../src/Device.vala"
		_tmp6_ = self->priv->_percentage;
#line 204 "../src/Device.vala"
		if (_tmp6_ == ((gdouble) 0)) {
#line 1383 "Device.c"
			PowerDeviceState _tmp7_;
#line 204 "../src/Device.vala"
			_tmp7_ = self->priv->_state;
#line 204 "../src/Device.vala"
			_tmp5_ = _tmp7_ == POWER_DEVICE_STATE_UNKNOWN;
#line 1389 "Device.c"
		} else {
#line 204 "../src/Device.vala"
			_tmp5_ = FALSE;
#line 1393 "Device.c"
		}
#line 204 "../src/Device.vala"
		if (_tmp5_) {
#line 205 "../src/Device.vala"
			power_device_set_description (self, _ ("Unknown. Device may be locked."));
#line 1399 "Device.c"
		} else {
			gdouble _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 207 "../src/Device.vala"
			_tmp8_ = self->priv->_percentage;
#line 207 "../src/Device.vala"
			_tmp9_ = g_strdup_printf ("%.0f%%", _tmp8_);
#line 207 "../src/Device.vala"
			_tmp10_ = _tmp9_;
#line 207 "../src/Device.vala"
			power_device_set_description (self, _tmp10_);
#line 207 "../src/Device.vala"
			_g_free0 (_tmp10_);
#line 1414 "Device.c"
		}
	}
}

gboolean
power_device_equal_func (PowerDevice* self,
                         PowerDevice* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 212 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 212 "../src/Device.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 213 "../src/Device.vala"
	if (self == other) {
#line 213 "../src/Device.vala"
		_tmp0_ = TRUE;
#line 1433 "Device.c"
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 213 "../src/Device.vala"
		_tmp1_ = self->priv->_path;
#line 213 "../src/Device.vala"
		_tmp2_ = other->priv->_path;
#line 213 "../src/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, _tmp2_) == 0;
#line 1443 "Device.c"
	}
#line 213 "../src/Device.vala"
	result = _tmp0_;
#line 213 "../src/Device.vala"
	return result;
#line 1449 "Device.c"
}

const gchar*
power_device_get_path (PowerDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 93 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "../src/Device.vala"
	_tmp0_ = self->priv->_path;
#line 93 "../src/Device.vala"
	result = _tmp0_;
#line 93 "../src/Device.vala"
	return result;
#line 1465 "Device.c"
}

static void
power_device_set_path (PowerDevice* self,
                       const gchar* value)
{
	gchar* old_value;
#line 93 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Device.vala"
	old_value = power_device_get_path (self);
#line 93 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1479 "Device.c"
		gchar* _tmp0_;
#line 93 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 93 "../src/Device.vala"
		_g_free0 (self->priv->_path);
#line 93 "../src/Device.vala"
		self->priv->_path = _tmp0_;
#line 93 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_PATH_PROPERTY]);
#line 1489 "Device.c"
	}
}

gboolean
power_device_get_power_supply (PowerDevice* self)
{
	gboolean result;
#line 99 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/Device.vala"
	result = self->priv->_power_supply;
#line 99 "../src/Device.vala"
	return result;
#line 1503 "Device.c"
}

static void
power_device_set_power_supply (PowerDevice* self,
                               gboolean value)
{
	gboolean old_value;
#line 99 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/Device.vala"
	old_value = power_device_get_power_supply (self);
#line 99 "../src/Device.vala"
	if (old_value != value) {
#line 99 "../src/Device.vala"
		self->priv->_power_supply = value;
#line 99 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_POWER_SUPPLY_PROPERTY]);
#line 1521 "Device.c"
	}
}

gdouble
power_device_get_percentage (PowerDevice* self)
{
	gdouble result;
#line 100 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 100 "../src/Device.vala"
	result = self->priv->_percentage;
#line 100 "../src/Device.vala"
	return result;
#line 1535 "Device.c"
}

static void
power_device_set_percentage (PowerDevice* self,
                             gdouble value)
{
	gdouble old_value;
#line 100 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/Device.vala"
	old_value = power_device_get_percentage (self);
#line 100 "../src/Device.vala"
	if (old_value != value) {
#line 100 "../src/Device.vala"
		self->priv->_percentage = value;
#line 100 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_PERCENTAGE_PROPERTY]);
#line 1553 "Device.c"
	}
}

gboolean
power_device_get_coarse_battery_level (PowerDevice* self)
{
	gboolean result;
#line 101 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/Device.vala"
	result = self->priv->_coarse_battery_level;
#line 101 "../src/Device.vala"
	return result;
#line 1567 "Device.c"
}

static void
power_device_set_coarse_battery_level (PowerDevice* self,
                                       gboolean value)
{
	gboolean old_value;
#line 101 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/Device.vala"
	old_value = power_device_get_coarse_battery_level (self);
#line 101 "../src/Device.vala"
	if (old_value != value) {
#line 101 "../src/Device.vala"
		self->priv->_coarse_battery_level = value;
#line 101 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY]);
#line 1585 "Device.c"
	}
}

const gchar*
power_device_get_description (PowerDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/Device.vala"
	_tmp0_ = self->priv->_description;
#line 102 "../src/Device.vala"
	result = _tmp0_;
#line 102 "../src/Device.vala"
	return result;
#line 1602 "Device.c"
}

static void
power_device_set_description (PowerDevice* self,
                              const gchar* value)
{
	gchar* old_value;
#line 102 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Device.vala"
	old_value = power_device_get_description (self);
#line 102 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1616 "Device.c"
		gchar* _tmp0_;
#line 102 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/Device.vala"
		_g_free0 (self->priv->_description);
#line 102 "../src/Device.vala"
		self->priv->_description = _tmp0_;
#line 102 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_DESCRIPTION_PROPERTY]);
#line 1626 "Device.c"
	}
}

const gchar*
power_device_get_icon_name (PowerDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 103 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../src/Device.vala"
	_tmp0_ = self->priv->_icon_name;
#line 103 "../src/Device.vala"
	result = _tmp0_;
#line 103 "../src/Device.vala"
	return result;
#line 1643 "Device.c"
}

static void
power_device_set_icon_name (PowerDevice* self,
                            const gchar* value)
{
	gchar* old_value;
#line 103 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/Device.vala"
	old_value = power_device_get_icon_name (self);
#line 103 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1657 "Device.c"
		gchar* _tmp0_;
#line 103 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 103 "../src/Device.vala"
		_g_free0 (self->priv->_icon_name);
#line 103 "../src/Device.vala"
		self->priv->_icon_name = _tmp0_;
#line 103 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_ICON_NAME_PROPERTY]);
#line 1667 "Device.c"
	}
}

const gchar*
power_device_get_model (PowerDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 104 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../src/Device.vala"
	_tmp0_ = self->priv->_model;
#line 104 "../src/Device.vala"
	result = _tmp0_;
#line 104 "../src/Device.vala"
	return result;
#line 1684 "Device.c"
}

static void
power_device_set_model (PowerDevice* self,
                        const gchar* value)
{
	gchar* old_value;
#line 104 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/Device.vala"
	old_value = power_device_get_model (self);
#line 104 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1698 "Device.c"
		gchar* _tmp0_;
#line 104 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 104 "../src/Device.vala"
		_g_free0 (self->priv->_model);
#line 104 "../src/Device.vala"
		self->priv->_model = _tmp0_;
#line 104 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_MODEL_PROPERTY]);
#line 1708 "Device.c"
	}
}

PowerDeviceState
power_device_get_state (PowerDevice* self)
{
	PowerDeviceState result;
#line 105 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "../src/Device.vala"
	result = self->priv->_state;
#line 105 "../src/Device.vala"
	return result;
#line 1722 "Device.c"
}

static void
power_device_set_state (PowerDevice* self,
                        PowerDeviceState value)
{
	PowerDeviceState old_value;
#line 105 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Device.vala"
	old_value = power_device_get_state (self);
#line 105 "../src/Device.vala"
	if (old_value != value) {
#line 105 "../src/Device.vala"
		self->priv->_state = value;
#line 105 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_STATE_PROPERTY]);
#line 1740 "Device.c"
	}
}

PowerDeviceType
power_device_get_device_type (PowerDevice* self)
{
	PowerDeviceType result;
#line 106 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "../src/Device.vala"
	result = self->priv->_device_type;
#line 106 "../src/Device.vala"
	return result;
#line 1754 "Device.c"
}

static void
power_device_set_device_type (PowerDevice* self,
                              PowerDeviceType value)
{
	PowerDeviceType old_value;
#line 106 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Device.vala"
	old_value = power_device_get_device_type (self);
#line 106 "../src/Device.vala"
	if (old_value != value) {
#line 106 "../src/Device.vala"
		self->priv->_device_type = value;
#line 106 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_device_properties[POWER_DEVICE_DEVICE_TYPE_PROPERTY]);
#line 1772 "Device.c"
	}
}

static void
_power_device_update_properties_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                   GVariant* changed_properties,
                                                                   gchar** invalidated_properties,
                                                                   gpointer self)
{
#line 127 "../src/Device.vala"
	power_device_update_properties ((PowerDevice*) self);
#line 1784 "Device.c"
}

static void
_power_device_update_description_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 130 "../src/Device.vala"
	power_device_update_description ((PowerDevice*) self);
#line 1794 "Device.c"
}

static GObject *
power_device_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerDevice * self;
	GError* _inner_error0_ = NULL;
#line 114 "../src/Device.vala"
	parent_class = G_OBJECT_CLASS (power_device_parent_class);
#line 114 "../src/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 114 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_DEVICE, PowerDevice);
#line 1812 "Device.c"
	{
		PowerUpowerDevice* _tmp0_ = NULL;
		const gchar* _tmp1_;
		PowerUpowerDevice* _tmp2_;
		PowerUpowerDevice* _tmp3_;
		PowerUpowerDevice* _tmp4_;
		PowerDeviceType _tmp5_;
		PowerDeviceType _tmp6_;
		PowerUpowerDevice* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		PowerUpowerDevice* _tmp10_;
#line 116 "../src/Device.vala"
		_tmp1_ = self->priv->_path;
#line 116 "../src/Device.vala"
		_tmp2_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DEVICE_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp1_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 116 "../src/Device.vala"
		_tmp0_ = (PowerUpowerDevice*) _tmp2_;
#line 116 "../src/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/Device.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 1835 "Device.c"
				goto __catch0_g_io_error;
			}
#line 116 "../src/Device.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/Device.vala"
			g_clear_error (&_inner_error0_);
#line 1842 "Device.c"
		}
#line 116 "../src/Device.vala"
		_tmp3_ = _tmp0_;
#line 116 "../src/Device.vala"
		_tmp0_ = NULL;
#line 116 "../src/Device.vala"
		_g_object_unref0 (self->priv->upower_device);
#line 116 "../src/Device.vala"
		self->priv->upower_device = _tmp3_;
#line 123 "../src/Device.vala"
		_tmp4_ = self->priv->upower_device;
#line 123 "../src/Device.vala"
		_tmp5_ = power_upower_device_get_device_type (_tmp4_);
#line 123 "../src/Device.vala"
		_tmp6_ = _tmp5_;
#line 123 "../src/Device.vala"
		power_device_set_device_type (self, _tmp6_);
#line 124 "../src/Device.vala"
		_tmp7_ = self->priv->upower_device;
#line 124 "../src/Device.vala"
		_tmp8_ = power_upower_device_get_power_supply (_tmp7_);
#line 124 "../src/Device.vala"
		_tmp9_ = _tmp8_;
#line 124 "../src/Device.vala"
		power_device_set_power_supply (self, _tmp9_);
#line 126 "../src/Device.vala"
		power_device_update_properties (self);
#line 127 "../src/Device.vala"
		_tmp10_ = self->priv->upower_device;
#line 127 "../src/Device.vala"
		g_signal_connect_object ((GDBusProxy*) _tmp10_, "g-properties-changed", (GCallback) _power_device_update_properties_g_dbus_proxy_g_properties_changed, self, 0);
#line 129 "../src/Device.vala"
		power_device_update_description (self);
#line 130 "../src/Device.vala"
		g_signal_connect_object ((GObject*) self, "notify::percentage", (GCallback) _power_device_update_description_g_object_notify, self, 0);
#line 115 "../src/Device.vala"
		_g_object_unref0 (_tmp0_);
#line 1880 "Device.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 115 "../src/Device.vala"
		e = _inner_error0_;
#line 115 "../src/Device.vala"
		_inner_error0_ = NULL;
#line 132 "../src/Device.vala"
		_tmp11_ = e;
#line 132 "../src/Device.vala"
		_tmp12_ = _tmp11_->message;
#line 132 "../src/Device.vala"
		g_critical ("Device.vala:132: %s", _tmp12_);
#line 115 "../src/Device.vala"
		_g_error_free0 (e);
#line 1900 "Device.c"
	}
	__finally0:
#line 115 "../src/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1909 "Device.c"
	}
#line 114 "../src/Device.vala"
	return obj;
#line 1913 "Device.c"
}

static void
power_device_class_init (PowerDeviceClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/Device.vala"
	power_device_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Device.vala"
	g_type_class_adjust_private_offset (klass, &PowerDevice_private_offset);
#line 21 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_device_get_property;
#line 21 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_device_set_property;
#line 21 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = power_device_constructor;
#line 21 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = power_device_finalize;
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_PATH_PROPERTY, power_device_properties[POWER_DEVICE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_POWER_SUPPLY_PROPERTY, power_device_properties[POWER_DEVICE_POWER_SUPPLY_PROPERTY] = g_param_spec_boolean ("power-supply", "power-supply", "power-supply", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_PERCENTAGE_PROPERTY, power_device_properties[POWER_DEVICE_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY, power_device_properties[POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY] = g_param_spec_boolean ("coarse-battery-level", "coarse-battery-level", "coarse-battery-level", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_DESCRIPTION_PROPERTY, power_device_properties[POWER_DEVICE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_ICON_NAME_PROPERTY, power_device_properties[POWER_DEVICE_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_MODEL_PROPERTY, power_device_properties[POWER_DEVICE_MODEL_PROPERTY] = g_param_spec_string ("model", "model", "model", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_STATE_PROPERTY, power_device_properties[POWER_DEVICE_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", POWER_DEVICE_TYPE_STATE, POWER_DEVICE_STATE_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_DEVICE_DEVICE_TYPE_PROPERTY, power_device_properties[POWER_DEVICE_DEVICE_TYPE_PROPERTY] = g_param_spec_enum ("device-type", "device-type", "device-type", POWER_DEVICE_TYPE_TYPE, POWER_DEVICE_TYPE_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1950 "Device.c"
}

static void
power_device_instance_init (PowerDevice * self,
                            gpointer klass)
{
#line 21 "../src/Device.vala"
	self->priv = power_device_get_instance_private (self);
#line 100 "../src/Device.vala"
	self->priv->_percentage = (gdouble) -1;
#line 101 "../src/Device.vala"
	self->priv->_coarse_battery_level = FALSE;
#line 105 "../src/Device.vala"
	self->priv->_state = POWER_DEVICE_STATE_UNKNOWN;
#line 106 "../src/Device.vala"
	self->priv->_device_type = POWER_DEVICE_TYPE_UNKNOWN;
#line 1967 "Device.c"
}

static void
power_device_finalize (GObject * obj)
{
	PowerDevice * self;
#line 21 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_DEVICE, PowerDevice);
#line 93 "../src/Device.vala"
	_g_free0 (self->priv->_path);
#line 102 "../src/Device.vala"
	_g_free0 (self->priv->_description);
#line 103 "../src/Device.vala"
	_g_free0 (self->priv->_icon_name);
#line 104 "../src/Device.vala"
	_g_free0 (self->priv->_model);
#line 108 "../src/Device.vala"
	_g_object_unref0 (self->priv->upower_device);
#line 21 "../src/Device.vala"
	G_OBJECT_CLASS (power_device_parent_class)->finalize (obj);
#line 1988 "Device.c"
}

static GType
power_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerDevice), 0, (GInstanceInitFunc) power_device_instance_init, NULL };
	GType power_device_type_id;
	power_device_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerDevice", &g_define_type_info, 0);
	PowerDevice_private_offset = g_type_add_instance_private (power_device_type_id, sizeof (PowerDevicePrivate));
	return power_device_type_id;
}

GType
power_device_get_type (void)
{
	static volatile gsize power_device_type_id__once = 0;
	if (g_once_init_enter (&power_device_type_id__once)) {
		GType power_device_type_id;
		power_device_type_id = power_device_get_type_once ();
		g_once_init_leave (&power_device_type_id__once, power_device_type_id);
	}
	return power_device_type_id__once;
}

static void
_vala_power_device_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	PowerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_DEVICE, PowerDevice);
#line 21 "../src/Device.vala"
	switch (property_id) {
#line 21 "../src/Device.vala"
		case POWER_DEVICE_PATH_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_string (value, power_device_get_path (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_POWER_SUPPLY_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_boolean (value, power_device_get_power_supply (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_PERCENTAGE_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_double (value, power_device_get_percentage (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_boolean (value, power_device_get_coarse_battery_level (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_DESCRIPTION_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_string (value, power_device_get_description (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_ICON_NAME_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_string (value, power_device_get_icon_name (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_MODEL_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_string (value, power_device_get_model (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_STATE_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_enum (value, power_device_get_state (self));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_DEVICE_TYPE_PROPERTY:
#line 21 "../src/Device.vala"
		g_value_set_enum (value, power_device_get_device_type (self));
#line 21 "../src/Device.vala"
		break;
#line 2077 "Device.c"
		default:
#line 21 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Device.vala"
		break;
#line 2083 "Device.c"
	}
}

static void
_vala_power_device_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	PowerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_DEVICE, PowerDevice);
#line 21 "../src/Device.vala"
	switch (property_id) {
#line 21 "../src/Device.vala"
		case POWER_DEVICE_PATH_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_path (self, g_value_get_string (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_POWER_SUPPLY_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_power_supply (self, g_value_get_boolean (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_PERCENTAGE_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_percentage (self, g_value_get_double (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_COARSE_BATTERY_LEVEL_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_coarse_battery_level (self, g_value_get_boolean (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_DESCRIPTION_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_description (self, g_value_get_string (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_ICON_NAME_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_icon_name (self, g_value_get_string (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_MODEL_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_model (self, g_value_get_string (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_STATE_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_state (self, g_value_get_enum (value));
#line 21 "../src/Device.vala"
		break;
#line 21 "../src/Device.vala"
		case POWER_DEVICE_DEVICE_TYPE_PROPERTY:
#line 21 "../src/Device.vala"
		power_device_set_device_type (self, g_value_get_enum (value));
#line 21 "../src/Device.vala"
		break;
#line 2151 "Device.c"
		default:
#line 21 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Device.vala"
		break;
#line 2157 "Device.c"
	}
}

