/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright (c) 2011-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <gio/gio.h>
#include "power.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <adwaita.h>
#include <granite-7.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_PLUG_0_PROPERTY,
	POWER_PLUG_NUM_PROPERTIES
};
static GParamSpec* power_plug_properties[POWER_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PowerPlugSearchData PowerPlugSearchData;

struct _PowerPlugPrivate {
	GtkBox* box;
	PowerMainView* main_view;
};

struct _PowerPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PowerPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
};

VALA_EXTERN GSettings* power_settings;
GSettings* power_settings = NULL;
static gint PowerPlug_private_offset;
static gpointer power_plug_parent_class = NULL;

static GtkWidget* power_plug_real_get_widget (SwitchboardPlug* base);
static void power_plug_real_shown (SwitchboardPlug* base);
static void power_plug_real_hidden (SwitchboardPlug* base);
static void power_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void power_plug_real_search_data_free (gpointer _data);
static void power_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean power_plug_real_search_co (PowerPlugSearchData* _data_);
static void power_plug_finalize (GObject * obj);
static GType power_plug_get_type_once (void);

static inline gpointer
power_plug_get_instance_private (PowerPlug* self)
{
	return G_STRUCT_MEMBER_P (self, PowerPlug_private_offset);
}

PowerPlug*
power_plug_construct (GType object_type)
{
	PowerPlug * self = NULL;
	GeeTreeMap* supported_settings = NULL;
	GeeTreeMap* _tmp0_;
#line 28 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 29 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 31 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 31 "../src/Plug.vala"
	supported_settings = _tmp0_;
#line 32 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) supported_settings, "power", NULL);
#line 34 "../src/Plug.vala"
	self = (PowerPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.settings.power", "display-name", _ ("Power"), "description", _ ("Configure display brightness, power buttons, and suspend behavior"), "icon", "preferences-system-power", "supported-settings", supported_settings, NULL);
#line 27 "../src/Plug.vala"
	_g_object_unref0 (supported_settings);
#line 27 "../src/Plug.vala"
	return self;
#line 163 "Plug.c"
}

PowerPlug*
power_plug_new (void)
{
#line 27 "../src/Plug.vala"
	return power_plug_construct (POWER_TYPE_PLUG);
#line 171 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 179 "Plug.c"
}

static GtkWidget*
power_plug_real_get_widget (SwitchboardPlug* base)
{
	PowerPlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* result;
#line 42 "../src/Plug.vala"
	self = (PowerPlug*) base;
#line 43 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 43 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 196 "Plug.c"
		GdkDisplay* _tmp1_;
		GtkIconTheme* _tmp2_;
		AdwHeaderBar* headerbar = NULL;
		AdwHeaderBar* _tmp3_ = NULL;
		AdwHeaderBar* _tmp4_;
		PowerMainView* _tmp5_ = NULL;
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
		AdwHeaderBar* _tmp8_;
		GtkBox* _tmp9_;
		PowerMainView* _tmp10_;
#line 44 "../src/Plug.vala"
		_tmp1_ = gdk_display_get_default ();
#line 44 "../src/Plug.vala"
		_tmp2_ = gtk_icon_theme_get_for_display (_tmp1_);
#line 44 "../src/Plug.vala"
		gtk_icon_theme_add_resource_path (_tmp2_, "/io/elementary/settings/power");
#line 46 "../src/Plug.vala"
		_tmp3_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 46 "../src/Plug.vala"
		adw_header_bar_set_show_title (_tmp3_, FALSE);
#line 46 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 46 "../src/Plug.vala"
		headerbar = _tmp3_;
#line 49 "../src/Plug.vala"
		_tmp4_ = headerbar;
#line 49 "../src/Plug.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp4_, GRANITE_STYLE_CLASS_FLAT);
#line 51 "../src/Plug.vala"
		_tmp5_ = power_main_view_new ();
#line 51 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp5_, TRUE);
#line 51 "../src/Plug.vala"
		g_object_ref_sink (_tmp5_);
#line 51 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_view);
#line 51 "../src/Plug.vala"
		self->priv->main_view = _tmp5_;
#line 55 "../src/Plug.vala"
		_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 55 "../src/Plug.vala"
		g_object_ref_sink (_tmp6_);
#line 55 "../src/Plug.vala"
		_g_object_unref0 (self->priv->box);
#line 55 "../src/Plug.vala"
		self->priv->box = _tmp6_;
#line 56 "../src/Plug.vala"
		_tmp7_ = self->priv->box;
#line 56 "../src/Plug.vala"
		_tmp8_ = headerbar;
#line 56 "../src/Plug.vala"
		gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 57 "../src/Plug.vala"
		_tmp9_ = self->priv->box;
#line 57 "../src/Plug.vala"
		_tmp10_ = self->priv->main_view;
#line 57 "../src/Plug.vala"
		gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (headerbar);
#line 258 "Plug.c"
	}
#line 60 "../src/Plug.vala"
	_tmp11_ = self->priv->box;
#line 60 "../src/Plug.vala"
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
#line 60 "../src/Plug.vala"
	result = _tmp12_;
#line 60 "../src/Plug.vala"
	return result;
#line 268 "Plug.c"
}

static void
power_plug_real_shown (SwitchboardPlug* base)
{
	PowerPlug * self;
	PowerMainView* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* _tmp2_;
	PowerPowerManager* _tmp3_;
#line 63 "../src/Plug.vala"
	self = (PowerPlug*) base;
#line 64 "../src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 64 "../src/Plug.vala"
	_tmp1_ = power_main_view_get_stack (_tmp0_);
#line 64 "../src/Plug.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/Plug.vala"
	if (_tmp2_ == NULL) {
#line 65 "../src/Plug.vala"
		return;
#line 291 "Plug.c"
	}
#line 68 "../src/Plug.vala"
	_tmp3_ = power_power_manager_get_default ();
#line 68 "../src/Plug.vala"
	if (power_power_manager_on_battery (_tmp3_)) {
#line 297 "Plug.c"
		PowerMainView* _tmp4_;
		GtkStack* _tmp5_;
		GtkStack* _tmp6_;
#line 69 "../src/Plug.vala"
		_tmp4_ = self->priv->main_view;
#line 69 "../src/Plug.vala"
		_tmp5_ = power_main_view_get_stack (_tmp4_);
#line 69 "../src/Plug.vala"
		_tmp6_ = _tmp5_;
#line 69 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp6_, "battery");
#line 309 "Plug.c"
	} else {
		PowerMainView* _tmp7_;
		GtkStack* _tmp8_;
		GtkStack* _tmp9_;
#line 71 "../src/Plug.vala"
		_tmp7_ = self->priv->main_view;
#line 71 "../src/Plug.vala"
		_tmp8_ = power_main_view_get_stack (_tmp7_);
#line 71 "../src/Plug.vala"
		_tmp9_ = _tmp8_;
#line 71 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp9_, "ac");
#line 322 "Plug.c"
	}
}

static void
power_plug_real_hidden (SwitchboardPlug* base)
{
	PowerPlug * self;
#line 75 "../src/Plug.vala"
	self = (PowerPlug*) base;
#line 332 "Plug.c"
}

static void
power_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	PowerPlug * self;
#line 79 "../src/Plug.vala"
	self = (PowerPlug*) base;
#line 79 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 344 "Plug.c"
}

static void
power_plug_real_search_data_free (gpointer _data)
{
	PowerPlugSearchData* _data_;
	_data_ = _data;
#line 23 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/Plug.vala"
	g_slice_free (PowerPlugSearchData, _data_);
#line 360 "Plug.c"
}

static void
power_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	PowerPlug * self;
	PowerPlugSearchData* _data_;
	PowerPlug* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 23 "../src/Plug.vala"
	self = (PowerPlug*) base;
#line 23 "../src/Plug.vala"
	_data_ = g_slice_new0 (PowerPlugSearchData);
#line 23 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, power_plug_real_search_data_free);
#line 23 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 23 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 23 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 23 "../src/Plug.vala"
	power_plug_real_search_co (_data_);
#line 395 "Plug.c"
}

static GeeTreeMap*
power_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	PowerPlugSearchData* _data_;
#line 23 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 23 "../src/Plug.vala"
	result = _data_->result;
#line 23 "../src/Plug.vala"
	_data_->result = NULL;
#line 23 "../src/Plug.vala"
	return result;
#line 412 "Plug.c"
}

static gboolean
power_plug_real_search_co (PowerPlugSearchData* _data_)
{
#line 84 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 84 "../src/Plug.vala"
		case 0:
#line 422 "Plug.c"
		goto _state_0;
		default:
#line 84 "../src/Plug.vala"
		g_assert_not_reached ();
#line 427 "Plug.c"
	}
	_state_0:
#line 85 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 85 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 85 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 85 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 86 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 86 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 86 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Automatically Adjust Brightness"));
#line 86 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 86 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
#line 86 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 87 "../src/Plug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 87 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 87 "../src/Plug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Automatically Save Power"));
#line 87 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 87 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "");
#line 87 "../src/Plug.vala"
	_g_free0 (_data_->_tmp10_);
#line 88 "../src/Plug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 88 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 88 "../src/Plug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Automatic Display Off"));
#line 88 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 88 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "");
#line 88 "../src/Plug.vala"
	_g_free0 (_data_->_tmp14_);
#line 89 "../src/Plug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 89 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 89 "../src/Plug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Battery Level"));
#line 89 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 89 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "");
#line 89 "../src/Plug.vala"
	_g_free0 (_data_->_tmp18_);
#line 90 "../src/Plug.vala"
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 90 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 90 "../src/Plug.vala"
	_data_->_tmp21_ = g_strdup_printf ("%s → %s", _data_->_tmp20_, _ ("Dim Display"));
#line 90 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 90 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, "");
#line 90 "../src/Plug.vala"
	_g_free0 (_data_->_tmp22_);
#line 91 "../src/Plug.vala"
	_data_->_tmp23_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 91 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 91 "../src/Plug.vala"
	_data_->_tmp25_ = g_strdup_printf ("%s → %s", _data_->_tmp24_, _ ("Display Brightness"));
#line 91 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 91 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp26_, "");
#line 91 "../src/Plug.vala"
	_g_free0 (_data_->_tmp26_);
#line 92 "../src/Plug.vala"
	_data_->_tmp27_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 92 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 92 "../src/Plug.vala"
	_data_->_tmp29_ = g_strdup_printf ("%s → %s", _data_->_tmp28_, _ ("Lid Close Behavior"));
#line 92 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 92 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp30_, "");
#line 92 "../src/Plug.vala"
	_g_free0 (_data_->_tmp30_);
#line 93 "../src/Plug.vala"
	_data_->_tmp31_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 93 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 93 "../src/Plug.vala"
	_data_->_tmp33_ = g_strdup_printf ("%s → %s", _data_->_tmp32_, _ ("Lid Close With External Display"));
#line 93 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 93 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp34_, "");
#line 93 "../src/Plug.vala"
	_g_free0 (_data_->_tmp34_);
#line 94 "../src/Plug.vala"
	_data_->_tmp35_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 94 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 94 "../src/Plug.vala"
	_data_->_tmp37_ = g_strdup_printf ("%s → %s", _data_->_tmp36_, _ ("Power Button Behavior"));
#line 94 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 94 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp38_, "");
#line 94 "../src/Plug.vala"
	_g_free0 (_data_->_tmp38_);
#line 95 "../src/Plug.vala"
	_data_->_tmp39_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 95 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 95 "../src/Plug.vala"
	_data_->_tmp41_ = g_strdup_printf ("%s → %s", _data_->_tmp40_, _ ("Suspend When Inactive For"));
#line 95 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 95 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp42_, "");
#line 95 "../src/Plug.vala"
	_g_free0 (_data_->_tmp42_);
#line 96 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 96 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 96 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 96 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 96 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 568 "Plug.c"
		}
	}
#line 96 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 96 "../src/Plug.vala"
	return FALSE;
#line 575 "Plug.c"
}

static void
power_plug_class_init (PowerPlugClass * klass,
                       gpointer klass_data)
{
#line 23 "../src/Plug.vala"
	power_plug_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &PowerPlug_private_offset);
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) power_plug_real_get_widget;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) power_plug_real_shown;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) power_plug_real_hidden;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) power_plug_real_search_callback;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) power_plug_real_search;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) power_plug_search_finish;
#line 23 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = power_plug_finalize;
#line 600 "Plug.c"
}

static void
power_plug_instance_init (PowerPlug * self,
                          gpointer klass)
{
#line 23 "../src/Plug.vala"
	self->priv = power_plug_get_instance_private (self);
#line 609 "Plug.c"
}

static void
power_plug_finalize (GObject * obj)
{
	PowerPlug * self;
#line 23 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_PLUG, PowerPlug);
#line 24 "../src/Plug.vala"
	_g_object_unref0 (self->priv->box);
#line 25 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_view);
#line 23 "../src/Plug.vala"
	G_OBJECT_CLASS (power_plug_parent_class)->finalize (obj);
#line 624 "Plug.c"
}

static GType
power_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerPlug), 0, (GInstanceInitFunc) power_plug_instance_init, NULL };
	GType power_plug_type_id;
	power_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "PowerPlug", &g_define_type_info, 0);
	PowerPlug_private_offset = g_type_add_instance_private (power_plug_type_id, sizeof (PowerPlugPrivate));
	return power_plug_type_id;
}

GType
power_plug_get_type (void)
{
	static volatile gsize power_plug_type_id__once = 0;
	if (g_once_init_enter (&power_plug_type_id__once)) {
		GType power_plug_type_id;
		power_plug_type_id = power_plug_get_type_once ();
		g_once_init_leave (&power_plug_type_id__once, power_plug_type_id);
	}
	return power_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	PowerPlug* plug = NULL;
	PowerPlug* _tmp0_;
	SwitchboardPlug* result;
#line 101 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 102 "../src/Plug.vala"
	g_debug ("Plug.vala:102: Activating Power plug");
#line 103 "../src/Plug.vala"
	_tmp0_ = power_plug_new ();
#line 103 "../src/Plug.vala"
	plug = _tmp0_;
#line 104 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 104 "../src/Plug.vala"
	return result;
#line 667 "Plug.c"
}

