/* PowerManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PowerManager.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0-or-later
 * SPDX-FileCopyrightText: 2011-2024 elementary, Inc. (https://elementary.io)
 */

#include "power.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define POWER_POWER_MANAGER_UPOWER_NAME "org.freedesktop.UPower"
#define POWER_POWER_MANAGER_UPOWER_PATH "/org/freedesktop/UPower"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define POWER_TYPE_UPOWER (power_upower_get_type ())
#define POWER_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER, PowerUpower))
#define POWER_IS_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER))
#define POWER_UPOWER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER, PowerUpowerIface))

typedef struct _PowerUpower PowerUpower;
typedef struct _PowerUpowerIface PowerUpowerIface;

#define POWER_TYPE_UPOWER_PROXY (power_upower_proxy_get_type ())
enum  {
	POWER_POWER_MANAGER_0_PROPERTY,
	POWER_POWER_MANAGER_BATTERIES_PROPERTY,
	POWER_POWER_MANAGER_DEVICES_PROPERTY,
	POWER_POWER_MANAGER_NUM_PROPERTIES
};
static GParamSpec* power_power_manager_properties[POWER_POWER_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerUpowerIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (PowerUpower* self, gint* result_length1, GError** error);
	gboolean (*get_on_battery) (PowerUpower* self);
	gboolean (*get_lid_is_present) (PowerUpower* self);
	gboolean (*get_low_on_battery) (PowerUpower* self);
};

struct _PowerPowerManagerPrivate {
	GListStore* _batteries;
	GListStore* _devices;
	PowerUpower* upower;
};

static gint PowerPowerManager_private_offset;
static gpointer power_power_manager_parent_class = NULL;
static GOnce power_power_manager_instance;
static GOnce power_power_manager_instance = G_ONCE_INIT;

VALA_EXTERN GType power_upower_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN GType power_upower_get_type (void) G_GNUC_CONST ;
static PowerPowerManager* __lambda4_ (void);
static gpointer ___lambda4__gthread_func (gpointer self);
VALA_EXTERN gboolean power_upower_get_on_battery (PowerUpower* self);
VALA_EXTERN gboolean power_upower_get_lid_is_present (PowerUpower* self);
static void power_power_manager_on_device_added (PowerPowerManager* self,
                                          const char* device_path);
static void power_power_manager_on_device_removed (PowerPowerManager* self,
                                            const char* device_path);
static void power_power_manager_set_batteries (PowerPowerManager* self,
                                        GListStore* value);
static void power_power_manager_set_devices (PowerPowerManager* self,
                                      GListStore* value);
static GObject * power_power_manager_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _power_power_manager_on_device_added_power_upower_device_added (PowerUpower* _sender,
                                                                     const char* device_path,
                                                                     gpointer self);
static void _power_power_manager_on_device_removed_power_upower_device_removed (PowerUpower* _sender,
                                                                         const char* device_path,
                                                                         gpointer self);
VALA_EXTERN char** power_upower_enumerate_devices (PowerUpower* self,
                                       gint* result_length1,
                                       GError** error);
static void power_power_manager_finalize (GObject * obj);
static GType power_power_manager_get_type_once (void);
static void _vala_power_power_manager_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_power_power_manager_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_power_manager_get_instance_private (PowerPowerManager* self)
{
	return G_STRUCT_MEMBER_P (self, PowerPowerManager_private_offset);
}

static PowerPowerManager*
__lambda4_ (void)
{
	PowerPowerManager* _tmp0_;
	PowerPowerManager* result;
#line 12 "../src/PowerManager.vala"
	_tmp0_ = power_power_manager_new ();
#line 12 "../src/PowerManager.vala"
	result = _tmp0_;
#line 12 "../src/PowerManager.vala"
	return result;
#line 130 "PowerManager.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ ();
#line 12 "../src/PowerManager.vala"
	return result;
#line 140 "PowerManager.c"
}

PowerPowerManager*
power_power_manager_get_default (void)
{
	gconstpointer _tmp0_;
	PowerPowerManager* result;
#line 12 "../src/PowerManager.vala"
	_tmp0_ = g_once (&power_power_manager_instance, ___lambda4__gthread_func, NULL);
#line 12 "../src/PowerManager.vala"
	result = (PowerPowerManager*) _tmp0_;
#line 12 "../src/PowerManager.vala"
	return result;
#line 154 "PowerManager.c"
}

gboolean
power_power_manager_on_battery (PowerPowerManager* self)
{
	PowerUpower* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 41 "../src/PowerManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/PowerManager.vala"
	_tmp0_ = self->priv->upower;
#line 42 "../src/PowerManager.vala"
	_tmp1_ = power_upower_get_on_battery (_tmp0_);
#line 42 "../src/PowerManager.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/PowerManager.vala"
	result = _tmp2_;
#line 42 "../src/PowerManager.vala"
	return result;
#line 176 "PowerManager.c"
}

gboolean
power_power_manager_has_lid (PowerPowerManager* self)
{
	PowerUpower* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 45 "../src/PowerManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/PowerManager.vala"
	_tmp0_ = self->priv->upower;
#line 46 "../src/PowerManager.vala"
	_tmp1_ = power_upower_get_lid_is_present (_tmp0_);
#line 46 "../src/PowerManager.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/PowerManager.vala"
	result = _tmp2_;
#line 46 "../src/PowerManager.vala"
	return result;
#line 198 "PowerManager.c"
}

static void
power_power_manager_on_device_added (PowerPowerManager* self,
                                     const char* device_path)
{
	PowerDevice* device = NULL;
	PowerDevice* _tmp0_;
	guint position = 0U;
	PowerDevice* _tmp1_;
	PowerDeviceType _tmp2_;
	PowerDeviceType _tmp3_;
	gboolean _tmp4_ = FALSE;
	PowerDevice* _tmp5_;
	PowerDeviceType _tmp6_;
	PowerDeviceType _tmp7_;
#line 49 "../src/PowerManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/PowerManager.vala"
	g_return_if_fail (device_path != NULL);
#line 50 "../src/PowerManager.vala"
	_tmp0_ = power_device_new ((const gchar*) device_path);
#line 50 "../src/PowerManager.vala"
	device = _tmp0_;
#line 51 "../src/PowerManager.vala"
	position = (guint) -1;
#line 53 "../src/PowerManager.vala"
	_tmp1_ = device;
#line 53 "../src/PowerManager.vala"
	_tmp2_ = power_device_get_device_type (_tmp1_);
#line 53 "../src/PowerManager.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/PowerManager.vala"
	if (_tmp3_ == POWER_DEVICE_TYPE_LINE_POWER) {
#line 54 "../src/PowerManager.vala"
		_g_object_unref0 (device);
#line 54 "../src/PowerManager.vala"
		return;
#line 237 "PowerManager.c"
	}
#line 61 "../src/PowerManager.vala"
	_tmp5_ = device;
#line 61 "../src/PowerManager.vala"
	_tmp6_ = power_device_get_device_type (_tmp5_);
#line 61 "../src/PowerManager.vala"
	_tmp7_ = _tmp6_;
#line 61 "../src/PowerManager.vala"
	if (_tmp7_ == POWER_DEVICE_TYPE_BATTERY) {
#line 247 "PowerManager.c"
		PowerDevice* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 61 "../src/PowerManager.vala"
		_tmp8_ = device;
#line 61 "../src/PowerManager.vala"
		_tmp9_ = power_device_get_power_supply (_tmp8_);
#line 61 "../src/PowerManager.vala"
		_tmp10_ = _tmp9_;
#line 61 "../src/PowerManager.vala"
		_tmp4_ = _tmp10_;
#line 259 "PowerManager.c"
	} else {
#line 61 "../src/PowerManager.vala"
		_tmp4_ = FALSE;
#line 263 "PowerManager.c"
	}
#line 61 "../src/PowerManager.vala"
	if (_tmp4_) {
#line 267 "PowerManager.c"
		gboolean found = FALSE;
		GListStore* _tmp11_;
		PowerDevice* _tmp12_;
		guint _tmp13_ = 0U;
		gboolean _tmp14_;
#line 62 "../src/PowerManager.vala"
		_tmp11_ = self->priv->_batteries;
#line 62 "../src/PowerManager.vala"
		_tmp12_ = device;
#line 62 "../src/PowerManager.vala"
		_tmp14_ = g_list_store_find_with_equal_func (_tmp11_, (GObject*) _tmp12_, (GEqualFunc) power_device_equal_func, &_tmp13_);
#line 62 "../src/PowerManager.vala"
		position = _tmp13_;
#line 62 "../src/PowerManager.vala"
		found = _tmp14_;
#line 64 "../src/PowerManager.vala"
		if (!found) {
#line 285 "PowerManager.c"
			GListStore* _tmp15_;
			PowerDevice* _tmp16_;
#line 65 "../src/PowerManager.vala"
			_tmp15_ = self->priv->_batteries;
#line 65 "../src/PowerManager.vala"
			_tmp16_ = device;
#line 65 "../src/PowerManager.vala"
			g_list_store_append (_tmp15_, (GObject*) _tmp16_);
#line 294 "PowerManager.c"
		}
	} else {
		gboolean found = FALSE;
		GListStore* _tmp17_;
		PowerDevice* _tmp18_;
		guint _tmp19_ = 0U;
		gboolean _tmp20_;
#line 68 "../src/PowerManager.vala"
		_tmp17_ = self->priv->_devices;
#line 68 "../src/PowerManager.vala"
		_tmp18_ = device;
#line 68 "../src/PowerManager.vala"
		_tmp20_ = g_list_store_find_with_equal_func (_tmp17_, (GObject*) _tmp18_, (GEqualFunc) power_device_equal_func, &_tmp19_);
#line 68 "../src/PowerManager.vala"
		position = _tmp19_;
#line 68 "../src/PowerManager.vala"
		found = _tmp20_;
#line 70 "../src/PowerManager.vala"
		if (!found) {
#line 314 "PowerManager.c"
			GListStore* _tmp21_;
			PowerDevice* _tmp22_;
#line 71 "../src/PowerManager.vala"
			_tmp21_ = self->priv->_devices;
#line 71 "../src/PowerManager.vala"
			_tmp22_ = device;
#line 71 "../src/PowerManager.vala"
			g_list_store_append (_tmp21_, (GObject*) _tmp22_);
#line 323 "PowerManager.c"
		}
	}
#line 49 "../src/PowerManager.vala"
	_g_object_unref0 (device);
#line 328 "PowerManager.c"
}

static void
power_power_manager_on_device_removed (PowerPowerManager* self,
                                       const char* device_path)
{
	guint position = 0U;
	GListStore* _tmp0_;
	PowerDevice* _tmp1_;
	PowerDevice* _tmp2_;
	guint _tmp3_ = 0U;
	GListStore* _tmp5_;
	PowerDevice* _tmp6_;
	PowerDevice* _tmp7_;
	guint _tmp8_ = 0U;
#line 76 "../src/PowerManager.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/PowerManager.vala"
	g_return_if_fail (device_path != NULL);
#line 77 "../src/PowerManager.vala"
	position = (guint) -1;
#line 80 "../src/PowerManager.vala"
	_tmp0_ = self->priv->_devices;
#line 80 "../src/PowerManager.vala"
	_tmp1_ = power_device_new ((const gchar*) device_path);
#line 80 "../src/PowerManager.vala"
	_tmp2_ = _tmp1_;
#line 80 "../src/PowerManager.vala"
	g_list_store_find_with_equal_func (_tmp0_, (GObject*) _tmp2_, (GEqualFunc) power_device_equal_func, &_tmp3_);
#line 80 "../src/PowerManager.vala"
	position = _tmp3_;
#line 80 "../src/PowerManager.vala"
	_g_object_unref0 (_tmp2_);
#line 81 "../src/PowerManager.vala"
	if (position != ((guint) -1)) {
#line 364 "PowerManager.c"
		GListStore* _tmp4_;
#line 82 "../src/PowerManager.vala"
		_tmp4_ = self->priv->_devices;
#line 82 "../src/PowerManager.vala"
		g_list_store_remove (_tmp4_, position);
#line 83 "../src/PowerManager.vala"
		return;
#line 372 "PowerManager.c"
	}
#line 86 "../src/PowerManager.vala"
	_tmp5_ = self->priv->_batteries;
#line 86 "../src/PowerManager.vala"
	_tmp6_ = power_device_new ((const gchar*) device_path);
#line 86 "../src/PowerManager.vala"
	_tmp7_ = _tmp6_;
#line 86 "../src/PowerManager.vala"
	g_list_store_find_with_equal_func (_tmp5_, (GObject*) _tmp7_, (GEqualFunc) power_device_equal_func, &_tmp8_);
#line 86 "../src/PowerManager.vala"
	position = _tmp8_;
#line 86 "../src/PowerManager.vala"
	_g_object_unref0 (_tmp7_);
#line 88 "../src/PowerManager.vala"
	if (position != ((guint) -1)) {
#line 388 "PowerManager.c"
		GListStore* _tmp9_;
#line 89 "../src/PowerManager.vala"
		_tmp9_ = self->priv->_batteries;
#line 89 "../src/PowerManager.vala"
		g_list_store_remove (_tmp9_, position);
#line 394 "PowerManager.c"
	}
}

PowerPowerManager*
power_power_manager_construct (GType object_type)
{
	PowerPowerManager * self = NULL;
#line 6 "../src/PowerManager.vala"
	self = (PowerPowerManager*) g_object_new (object_type, NULL);
#line 6 "../src/PowerManager.vala"
	return self;
#line 406 "PowerManager.c"
}

PowerPowerManager*
power_power_manager_new (void)
{
#line 6 "../src/PowerManager.vala"
	return power_power_manager_construct (POWER_TYPE_POWER_MANAGER);
#line 414 "PowerManager.c"
}

GListStore*
power_power_manager_get_batteries (PowerPowerManager* self)
{
	GListStore* result;
	GListStore* _tmp0_;
#line 15 "../src/PowerManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/PowerManager.vala"
	_tmp0_ = self->priv->_batteries;
#line 15 "../src/PowerManager.vala"
	result = _tmp0_;
#line 15 "../src/PowerManager.vala"
	return result;
#line 430 "PowerManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/PowerManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 438 "PowerManager.c"
}

static void
power_power_manager_set_batteries (PowerPowerManager* self,
                                   GListStore* value)
{
	GListStore* old_value;
#line 15 "../src/PowerManager.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/PowerManager.vala"
	old_value = power_power_manager_get_batteries (self);
#line 15 "../src/PowerManager.vala"
	if (old_value != value) {
#line 452 "PowerManager.c"
		GListStore* _tmp0_;
#line 15 "../src/PowerManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 15 "../src/PowerManager.vala"
		_g_object_unref0 (self->priv->_batteries);
#line 15 "../src/PowerManager.vala"
		self->priv->_batteries = _tmp0_;
#line 15 "../src/PowerManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_power_manager_properties[POWER_POWER_MANAGER_BATTERIES_PROPERTY]);
#line 462 "PowerManager.c"
	}
}

GListStore*
power_power_manager_get_devices (PowerPowerManager* self)
{
	GListStore* result;
	GListStore* _tmp0_;
#line 16 "../src/PowerManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/PowerManager.vala"
	_tmp0_ = self->priv->_devices;
#line 16 "../src/PowerManager.vala"
	result = _tmp0_;
#line 16 "../src/PowerManager.vala"
	return result;
#line 479 "PowerManager.c"
}

static void
power_power_manager_set_devices (PowerPowerManager* self,
                                 GListStore* value)
{
	GListStore* old_value;
#line 16 "../src/PowerManager.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/PowerManager.vala"
	old_value = power_power_manager_get_devices (self);
#line 16 "../src/PowerManager.vala"
	if (old_value != value) {
#line 493 "PowerManager.c"
		GListStore* _tmp0_;
#line 16 "../src/PowerManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 16 "../src/PowerManager.vala"
		_g_object_unref0 (self->priv->_devices);
#line 16 "../src/PowerManager.vala"
		self->priv->_devices = _tmp0_;
#line 16 "../src/PowerManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_power_manager_properties[POWER_POWER_MANAGER_DEVICES_PROPERTY]);
#line 503 "PowerManager.c"
	}
}

static void
_power_power_manager_on_device_added_power_upower_device_added (PowerUpower* _sender,
                                                                const char* device_path,
                                                                gpointer self)
{
#line 26 "../src/PowerManager.vala"
	power_power_manager_on_device_added ((PowerPowerManager*) self, device_path);
#line 514 "PowerManager.c"
}

static void
_power_power_manager_on_device_removed_power_upower_device_removed (PowerUpower* _sender,
                                                                    const char* device_path,
                                                                    gpointer self)
{
#line 27 "../src/PowerManager.vala"
	power_power_manager_on_device_removed ((PowerPowerManager*) self, device_path);
#line 524 "PowerManager.c"
}

static GObject *
power_power_manager_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerPowerManager * self;
	GListStore* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	GListStore* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 20 "../src/PowerManager.vala"
	parent_class = G_OBJECT_CLASS (power_power_manager_parent_class);
#line 20 "../src/PowerManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 20 "../src/PowerManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MANAGER, PowerPowerManager);
#line 21 "../src/PowerManager.vala"
	_tmp0_ = g_list_store_new (POWER_TYPE_DEVICE);
#line 21 "../src/PowerManager.vala"
	_tmp1_ = _tmp0_;
#line 21 "../src/PowerManager.vala"
	power_power_manager_set_batteries (self, _tmp1_);
#line 21 "../src/PowerManager.vala"
	_g_object_unref0 (_tmp1_);
#line 22 "../src/PowerManager.vala"
	_tmp2_ = g_list_store_new (POWER_TYPE_DEVICE);
#line 22 "../src/PowerManager.vala"
	_tmp3_ = _tmp2_;
#line 22 "../src/PowerManager.vala"
	power_power_manager_set_devices (self, _tmp3_);
#line 22 "../src/PowerManager.vala"
	_g_object_unref0 (_tmp3_);
#line 562 "PowerManager.c"
	{
		PowerUpower* _tmp4_ = NULL;
		PowerUpower* _tmp5_;
		PowerUpower* _tmp6_;
		PowerUpower* _tmp7_;
		PowerUpower* _tmp8_;
#line 25 "../src/PowerManager.vala"
		_tmp5_ = (PowerUpower*) g_initable_new (POWER_TYPE_UPOWER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", POWER_POWER_MANAGER_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_POWER_MANAGER_UPOWER_PATH, "g-interface-name", "org.freedesktop.UPower", NULL);
#line 25 "../src/PowerManager.vala"
		_tmp4_ = (PowerUpower*) _tmp5_;
#line 25 "../src/PowerManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 575 "PowerManager.c"
			goto __catch0_g_error;
		}
#line 25 "../src/PowerManager.vala"
		_tmp6_ = _tmp4_;
#line 25 "../src/PowerManager.vala"
		_tmp4_ = NULL;
#line 25 "../src/PowerManager.vala"
		_g_object_unref0 (self->priv->upower);
#line 25 "../src/PowerManager.vala"
		self->priv->upower = _tmp6_;
#line 26 "../src/PowerManager.vala"
		_tmp7_ = self->priv->upower;
#line 26 "../src/PowerManager.vala"
		g_signal_connect_object (_tmp7_, "device-added", (GCallback) _power_power_manager_on_device_added_power_upower_device_added, self, 0);
#line 27 "../src/PowerManager.vala"
		_tmp8_ = self->priv->upower;
#line 27 "../src/PowerManager.vala"
		g_signal_connect_object (_tmp8_, "device-removed", (GCallback) _power_power_manager_on_device_removed_power_upower_device_removed, self, 0);
#line 594 "PowerManager.c"
		{
			char** _tmp9_ = NULL;
			PowerUpower* _tmp10_;
			gint _tmp11_ = 0;
			char** _tmp12_;
			gint _tmp9__length1;
			gint __tmp9__size_;
#line 30 "../src/PowerManager.vala"
			_tmp10_ = self->priv->upower;
#line 30 "../src/PowerManager.vala"
			_tmp12_ = power_upower_enumerate_devices (_tmp10_, &_tmp11_, &_inner_error0_);
#line 30 "../src/PowerManager.vala"
			_tmp9_ = _tmp12_;
#line 30 "../src/PowerManager.vala"
			_tmp9__length1 = _tmp11_;
#line 30 "../src/PowerManager.vala"
			__tmp9__size_ = _tmp9__length1;
#line 30 "../src/PowerManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "PowerManager.c"
				goto __catch1_g_error;
			}
			{
				char** path_collection = NULL;
				gint path_collection_length1 = 0;
				gint _path_collection_size_ = 0;
				gint path_it = 0;
#line 30 "../src/PowerManager.vala"
				path_collection = _tmp9_;
#line 30 "../src/PowerManager.vala"
				path_collection_length1 = _tmp9__length1;
#line 30 "../src/PowerManager.vala"
				for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 628 "PowerManager.c"
					const char* path = NULL;
#line 30 "../src/PowerManager.vala"
					path = path_collection[path_it];
#line 632 "PowerManager.c"
					{
						const char* _tmp13_;
#line 31 "../src/PowerManager.vala"
						_tmp13_ = path;
#line 31 "../src/PowerManager.vala"
						power_power_manager_on_device_added (self, _tmp13_);
#line 639 "PowerManager.c"
					}
				}
			}
#line 29 "../src/PowerManager.vala"
			_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 645 "PowerManager.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 29 "../src/PowerManager.vala"
			e = _inner_error0_;
#line 29 "../src/PowerManager.vala"
			_inner_error0_ = NULL;
#line 34 "../src/PowerManager.vala"
			_tmp14_ = e;
#line 34 "../src/PowerManager.vala"
			_tmp15_ = _tmp14_->message;
#line 34 "../src/PowerManager.vala"
			g_critical ("PowerManager.vala:34: acpi couldn't get upower devices: %s", _tmp15_);
#line 29 "../src/PowerManager.vala"
			_g_error_free0 (e);
#line 665 "PowerManager.c"
		}
		__finally1:
#line 29 "../src/PowerManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29 "../src/PowerManager.vala"
			_g_object_unref0 (_tmp4_);
#line 672 "PowerManager.c"
			goto __catch0_g_error;
		}
#line 24 "../src/PowerManager.vala"
		_g_object_unref0 (_tmp4_);
#line 677 "PowerManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 24 "../src/PowerManager.vala"
		e = _inner_error0_;
#line 24 "../src/PowerManager.vala"
		_inner_error0_ = NULL;
#line 37 "../src/PowerManager.vala"
		_tmp16_ = e;
#line 37 "../src/PowerManager.vala"
		_tmp17_ = _tmp16_->message;
#line 37 "../src/PowerManager.vala"
		g_critical ("PowerManager.vala:37: Connecting to UPower bus failed: %s", _tmp17_);
#line 24 "../src/PowerManager.vala"
		_g_error_free0 (e);
#line 697 "PowerManager.c"
	}
	__finally0:
#line 24 "../src/PowerManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24 "../src/PowerManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 24 "../src/PowerManager.vala"
		g_clear_error (&_inner_error0_);
#line 706 "PowerManager.c"
	}
#line 20 "../src/PowerManager.vala"
	return obj;
#line 710 "PowerManager.c"
}

static void
power_power_manager_class_init (PowerPowerManagerClass * klass,
                                gpointer klass_data)
{
#line 6 "../src/PowerManager.vala"
	power_power_manager_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/PowerManager.vala"
	g_type_class_adjust_private_offset (klass, &PowerPowerManager_private_offset);
#line 6 "../src/PowerManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_power_manager_get_property;
#line 6 "../src/PowerManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_power_manager_set_property;
#line 6 "../src/PowerManager.vala"
	G_OBJECT_CLASS (klass)->constructor = power_power_manager_constructor;
#line 6 "../src/PowerManager.vala"
	G_OBJECT_CLASS (klass)->finalize = power_power_manager_finalize;
#line 6 "../src/PowerManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_POWER_MANAGER_BATTERIES_PROPERTY, power_power_manager_properties[POWER_POWER_MANAGER_BATTERIES_PROPERTY] = g_param_spec_object ("batteries", "batteries", "batteries", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6 "../src/PowerManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_POWER_MANAGER_DEVICES_PROPERTY, power_power_manager_properties[POWER_POWER_MANAGER_DEVICES_PROPERTY] = g_param_spec_object ("devices", "devices", "devices", g_list_store_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 733 "PowerManager.c"
}

static void
power_power_manager_instance_init (PowerPowerManager * self,
                                   gpointer klass)
{
#line 6 "../src/PowerManager.vala"
	self->priv = power_power_manager_get_instance_private (self);
#line 742 "PowerManager.c"
}

static void
power_power_manager_finalize (GObject * obj)
{
	PowerPowerManager * self;
#line 6 "../src/PowerManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MANAGER, PowerPowerManager);
#line 15 "../src/PowerManager.vala"
	_g_object_unref0 (self->priv->_batteries);
#line 16 "../src/PowerManager.vala"
	_g_object_unref0 (self->priv->_devices);
#line 18 "../src/PowerManager.vala"
	_g_object_unref0 (self->priv->upower);
#line 6 "../src/PowerManager.vala"
	G_OBJECT_CLASS (power_power_manager_parent_class)->finalize (obj);
#line 759 "PowerManager.c"
}

static GType
power_power_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerPowerManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_power_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerPowerManager), 0, (GInstanceInitFunc) power_power_manager_instance_init, NULL };
	GType power_power_manager_type_id;
	power_power_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerPowerManager", &g_define_type_info, 0);
	PowerPowerManager_private_offset = g_type_add_instance_private (power_power_manager_type_id, sizeof (PowerPowerManagerPrivate));
	return power_power_manager_type_id;
}

GType
power_power_manager_get_type (void)
{
	static volatile gsize power_power_manager_type_id__once = 0;
	if (g_once_init_enter (&power_power_manager_type_id__once)) {
		GType power_power_manager_type_id;
		power_power_manager_type_id = power_power_manager_get_type_once ();
		g_once_init_leave (&power_power_manager_type_id__once, power_power_manager_type_id);
	}
	return power_power_manager_type_id__once;
}

static void
_vala_power_power_manager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PowerPowerManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MANAGER, PowerPowerManager);
#line 6 "../src/PowerManager.vala"
	switch (property_id) {
#line 6 "../src/PowerManager.vala"
		case POWER_POWER_MANAGER_BATTERIES_PROPERTY:
#line 6 "../src/PowerManager.vala"
		g_value_set_object (value, power_power_manager_get_batteries (self));
#line 6 "../src/PowerManager.vala"
		break;
#line 6 "../src/PowerManager.vala"
		case POWER_POWER_MANAGER_DEVICES_PROPERTY:
#line 6 "../src/PowerManager.vala"
		g_value_set_object (value, power_power_manager_get_devices (self));
#line 6 "../src/PowerManager.vala"
		break;
#line 806 "PowerManager.c"
		default:
#line 6 "../src/PowerManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/PowerManager.vala"
		break;
#line 812 "PowerManager.c"
	}
}

static void
_vala_power_power_manager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PowerPowerManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MANAGER, PowerPowerManager);
#line 6 "../src/PowerManager.vala"
	switch (property_id) {
#line 6 "../src/PowerManager.vala"
		case POWER_POWER_MANAGER_BATTERIES_PROPERTY:
#line 6 "../src/PowerManager.vala"
		power_power_manager_set_batteries (self, g_value_get_object (value));
#line 6 "../src/PowerManager.vala"
		break;
#line 6 "../src/PowerManager.vala"
		case POWER_POWER_MANAGER_DEVICES_PROPERTY:
#line 6 "../src/PowerManager.vala"
		power_power_manager_set_devices (self, g_value_get_object (value));
#line 6 "../src/PowerManager.vala"
		break;
#line 838 "PowerManager.c"
		default:
#line 6 "../src/PowerManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/PowerManager.vala"
		break;
#line 844 "PowerManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

