/* PowerModeButton.c generated by valac 0.56.17, the Vala compiler
 * generated from PowerModeButton.vala, do not modify */

/*
 * Copyright 2021-2022 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Authored by: Subhadeep Jasu <subhajasu@gmail.com>
 */

#include "power.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <granite-7.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_POWER_MODE_BUTTON_0_PROPERTY,
	POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY,
	POWER_POWER_MODE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _PowerPowerModeButtonPrivate {
	gchar* _settings_key;
	GtkCheckButton* saver_radio;
	GtkCheckButton* balanced_radio;
	GtkCheckButton* performance_radio;
};

static gint PowerPowerModeButton_private_offset;
static gpointer power_power_mode_button_parent_class = NULL;
static gboolean power_power_mode_button__successfully_initialized;
static gboolean power_power_mode_button__successfully_initialized = TRUE;
static PowerPowerProfile* power_power_mode_button_pprofile;
static PowerPowerProfile* power_power_mode_button_pprofile = NULL;
static GSettings* power_power_mode_button_settings;
static GSettings* power_power_mode_button_settings = NULL;

static void power_power_mode_button_update_active_profile (PowerPowerModeButton* self);
static void power_power_mode_button_set_successfully_initialized (gboolean value);
static GObject * power_power_mode_button_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _power_power_mode_button___lambda12_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda12__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                     gpointer self);
static void _power_power_mode_button___lambda13_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda13__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                     gpointer self);
static void _power_power_mode_button___lambda14_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda14__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                     gpointer self);
static void power_power_mode_button_finalize (GObject * obj);
static GType power_power_mode_button_get_type_once (void);
static void _vala_power_power_mode_button_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_power_power_mode_button_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_power_mode_button_get_instance_private (PowerPowerModeButton* self)
{
	return G_STRUCT_MEMBER_P (self, PowerPowerModeButton_private_offset);
}

PowerPowerModeButton*
power_power_mode_button_construct (GType object_type,
                                   gboolean on_battery)
{
	PowerPowerModeButton * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 35 "../src/Widgets/PowerModeButton.vala"
	if (on_battery) {
#line 35 "../src/Widgets/PowerModeButton.vala"
		_tmp0_ = "profile-on-good-battery";
#line 119 "PowerModeButton.c"
	} else {
#line 35 "../src/Widgets/PowerModeButton.vala"
		_tmp0_ = "profile-plugged-in";
#line 123 "PowerModeButton.c"
	}
#line 35 "../src/Widgets/PowerModeButton.vala"
	self = (PowerPowerModeButton*) g_object_new (object_type, "settings-key", _tmp0_, NULL);
#line 34 "../src/Widgets/PowerModeButton.vala"
	return self;
#line 129 "PowerModeButton.c"
}

PowerPowerModeButton*
power_power_mode_button_new (gboolean on_battery)
{
#line 34 "../src/Widgets/PowerModeButton.vala"
	return power_power_mode_button_construct (POWER_TYPE_POWER_MODE_BUTTON, on_battery);
#line 137 "PowerModeButton.c"
}

static void
power_power_mode_button_update_active_profile (PowerPowerModeButton* self)
{
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 149 "../src/Widgets/PowerModeButton.vala"
	static GQuark _tmp4_label0 = 0;
#line 149 "../src/Widgets/PowerModeButton.vala"
	static GQuark _tmp4_label1 = 0;
#line 149 "../src/Widgets/PowerModeButton.vala"
	static GQuark _tmp4_label2 = 0;
#line 148 "../src/Widgets/PowerModeButton.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = power_power_mode_button_settings;
#line 149 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = self->priv->_settings_key;
#line 149 "../src/Widgets/PowerModeButton.vala"
	_tmp2_ = g_settings_get_string (_tmp0_, _tmp1_);
#line 149 "../src/Widgets/PowerModeButton.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/Widgets/PowerModeButton.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 149 "../src/Widgets/PowerModeButton.vala"
	g_free (_tmp3_);
#line 149 "../src/Widgets/PowerModeButton.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("power-saver")))) {
#line 149 "../src/Widgets/PowerModeButton.vala"
		switch (0) {
#line 172 "PowerModeButton.c"
			default:
			{
				GtkCheckButton* _tmp6_;
#line 151 "../src/Widgets/PowerModeButton.vala"
				_tmp6_ = self->priv->saver_radio;
#line 151 "../src/Widgets/PowerModeButton.vala"
				gtk_check_button_set_active (_tmp6_, TRUE);
#line 152 "../src/Widgets/PowerModeButton.vala"
				break;
#line 182 "PowerModeButton.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("balanced")))) {
#line 149 "../src/Widgets/PowerModeButton.vala"
		switch (0) {
#line 188 "PowerModeButton.c"
			default:
			{
				GtkCheckButton* _tmp7_;
#line 154 "../src/Widgets/PowerModeButton.vala"
				_tmp7_ = self->priv->balanced_radio;
#line 154 "../src/Widgets/PowerModeButton.vala"
				gtk_check_button_set_active (_tmp7_, TRUE);
#line 155 "../src/Widgets/PowerModeButton.vala"
				break;
#line 198 "PowerModeButton.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("performance")))) {
#line 149 "../src/Widgets/PowerModeButton.vala"
		switch (0) {
#line 204 "PowerModeButton.c"
			default:
			{
				GtkCheckButton* _tmp8_;
#line 157 "../src/Widgets/PowerModeButton.vala"
				_tmp8_ = self->priv->performance_radio;
#line 157 "../src/Widgets/PowerModeButton.vala"
				gtk_check_button_set_active (_tmp8_, TRUE);
#line 158 "../src/Widgets/PowerModeButton.vala"
				break;
#line 214 "PowerModeButton.c"
			}
		}
	}
}

gboolean
power_power_mode_button_get_successfully_initialized (void)
{
	gboolean result;
#line 23 "../src/Widgets/PowerModeButton.vala"
	result = power_power_mode_button__successfully_initialized;
#line 23 "../src/Widgets/PowerModeButton.vala"
	return result;
#line 228 "PowerModeButton.c"
}

static void
power_power_mode_button_set_successfully_initialized (gboolean value)
{
#line 23 "../src/Widgets/PowerModeButton.vala"
	power_power_mode_button__successfully_initialized = value;
#line 236 "PowerModeButton.c"
}

const gchar*
power_power_mode_button_get_settings_key (PowerPowerModeButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/Widgets/PowerModeButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = self->priv->_settings_key;
#line 28 "../src/Widgets/PowerModeButton.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/PowerModeButton.vala"
	return result;
#line 252 "PowerModeButton.c"
}

static void
power_power_mode_button_set_settings_key (PowerPowerModeButton* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 28 "../src/Widgets/PowerModeButton.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/PowerModeButton.vala"
	old_value = power_power_mode_button_get_settings_key (self);
#line 28 "../src/Widgets/PowerModeButton.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 266 "PowerModeButton.c"
		gchar* _tmp0_;
#line 28 "../src/Widgets/PowerModeButton.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/Widgets/PowerModeButton.vala"
		_g_free0 (self->priv->_settings_key);
#line 28 "../src/Widgets/PowerModeButton.vala"
		self->priv->_settings_key = _tmp0_;
#line 28 "../src/Widgets/PowerModeButton.vala"
		g_object_notify_by_pspec ((GObject *) self, power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY]);
#line 276 "PowerModeButton.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../src/Widgets/PowerModeButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 285 "PowerModeButton.c"
}

static void
_power_power_mode_button___lambda12_ (PowerPowerModeButton* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 130 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = self->priv->saver_radio;
#line 130 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 130 "../src/Widgets/PowerModeButton.vala"
	_tmp2_ = _tmp1_;
#line 130 "../src/Widgets/PowerModeButton.vala"
	if (_tmp2_) {
#line 302 "PowerModeButton.c"
		GSettings* _tmp3_;
		const gchar* _tmp4_;
#line 131 "../src/Widgets/PowerModeButton.vala"
		_tmp3_ = power_power_mode_button_settings;
#line 131 "../src/Widgets/PowerModeButton.vala"
		_tmp4_ = self->priv->_settings_key;
#line 131 "../src/Widgets/PowerModeButton.vala"
		g_settings_set_string (_tmp3_, _tmp4_, "power-saver");
#line 311 "PowerModeButton.c"
	}
}

static void
__power_power_mode_button___lambda12__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                gpointer self)
{
#line 129 "../src/Widgets/PowerModeButton.vala"
	_power_power_mode_button___lambda12_ ((PowerPowerModeButton*) self);
#line 321 "PowerModeButton.c"
}

static void
_power_power_mode_button___lambda13_ (PowerPowerModeButton* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 136 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = self->priv->balanced_radio;
#line 136 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 136 "../src/Widgets/PowerModeButton.vala"
	_tmp2_ = _tmp1_;
#line 136 "../src/Widgets/PowerModeButton.vala"
	if (_tmp2_) {
#line 338 "PowerModeButton.c"
		GSettings* _tmp3_;
		const gchar* _tmp4_;
#line 137 "../src/Widgets/PowerModeButton.vala"
		_tmp3_ = power_power_mode_button_settings;
#line 137 "../src/Widgets/PowerModeButton.vala"
		_tmp4_ = self->priv->_settings_key;
#line 137 "../src/Widgets/PowerModeButton.vala"
		g_settings_set_string (_tmp3_, _tmp4_, "balanced");
#line 347 "PowerModeButton.c"
	}
}

static void
__power_power_mode_button___lambda13__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                gpointer self)
{
#line 135 "../src/Widgets/PowerModeButton.vala"
	_power_power_mode_button___lambda13_ ((PowerPowerModeButton*) self);
#line 357 "PowerModeButton.c"
}

static void
_power_power_mode_button___lambda14_ (PowerPowerModeButton* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 142 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = self->priv->performance_radio;
#line 142 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 142 "../src/Widgets/PowerModeButton.vala"
	_tmp2_ = _tmp1_;
#line 142 "../src/Widgets/PowerModeButton.vala"
	if (_tmp2_) {
#line 374 "PowerModeButton.c"
		GSettings* _tmp3_;
		const gchar* _tmp4_;
#line 143 "../src/Widgets/PowerModeButton.vala"
		_tmp3_ = power_power_mode_button_settings;
#line 143 "../src/Widgets/PowerModeButton.vala"
		_tmp4_ = self->priv->_settings_key;
#line 143 "../src/Widgets/PowerModeButton.vala"
		g_settings_set_string (_tmp3_, _tmp4_, "performance");
#line 383 "PowerModeButton.c"
	}
}

static void
__power_power_mode_button___lambda14__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                                gpointer self)
{
#line 141 "../src/Widgets/PowerModeButton.vala"
	_power_power_mode_button___lambda14_ ((PowerPowerModeButton*) self);
#line 393 "PowerModeButton.c"
}

static GObject *
power_power_mode_button_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerPowerModeButton * self;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	GraniteHeaderLabel* header = NULL;
	GraniteHeaderLabel* _tmp3_ = NULL;
	GtkImage* saver_icon = NULL;
	GtkImage* _tmp4_ = NULL;
	GtkLabel* saver_label = NULL;
	GtkLabel* _tmp5_;
	GtkBox* saver_button_box = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkImage* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkCheckButton* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkBox* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkImage* balanced_icon = NULL;
	GtkImage* _tmp15_ = NULL;
	GtkLabel* balanced_label = NULL;
	GtkLabel* _tmp16_;
	GtkBox* balanced_button_box = NULL;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkImage* _tmp19_;
	GtkBox* _tmp20_;
	GtkLabel* _tmp21_;
	GtkCheckButton* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_ = NULL;
	GtkCheckButton* _tmp25_;
	GtkBox* _tmp26_;
	GtkCheckButton* _tmp27_;
	GtkImage* performance_icon = NULL;
	GtkImage* _tmp28_ = NULL;
	GtkLabel* performance_label = NULL;
	GtkLabel* _tmp29_;
	GtkBox* performance_button_box = NULL;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkImage* _tmp32_;
	GtkBox* _tmp33_;
	GtkLabel* _tmp34_;
	GtkCheckButton* _tmp35_;
	GtkCheckButton* _tmp36_;
	GtkCheckButton* _tmp37_ = NULL;
	GtkCheckButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkCheckButton* _tmp40_;
	GraniteHeaderLabel* _tmp41_;
	PowerPowerProfile* _tmp42_;
	GHashTable** _tmp43_;
	gint _tmp43__length1;
	gint _tmp44_ = 0;
	GHashTable** _tmp45_;
	gint _tmp45__length1;
	GtkCheckButton* _tmp55_;
	GtkCheckButton* _tmp56_;
	GtkCheckButton* _tmp57_;
#line 55 "../src/Widgets/PowerModeButton.vala"
	parent_class = G_OBJECT_CLASS (power_power_mode_button_parent_class);
#line 55 "../src/Widgets/PowerModeButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "../src/Widgets/PowerModeButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
#line 56 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = power_power_mode_button_settings;
#line 56 "../src/Widgets/PowerModeButton.vala"
	if (_tmp1_ == NULL) {
#line 56 "../src/Widgets/PowerModeButton.vala"
		_tmp0_ = TRUE;
#line 476 "PowerModeButton.c"
	} else {
		PowerPowerProfile* _tmp2_;
#line 56 "../src/Widgets/PowerModeButton.vala"
		_tmp2_ = power_power_mode_button_pprofile;
#line 56 "../src/Widgets/PowerModeButton.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 483 "PowerModeButton.c"
	}
#line 56 "../src/Widgets/PowerModeButton.vala"
	if (_tmp0_) {
#line 57 "../src/Widgets/PowerModeButton.vala"
		return obj;
#line 489 "PowerModeButton.c"
	}
#line 60 "../src/Widgets/PowerModeButton.vala"
	_tmp3_ = granite_header_label_new (_ ("Power Mode"));
#line 60 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 60 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp3_);
#line 60 "../src/Widgets/PowerModeButton.vala"
	header = _tmp3_;
#line 64 "../src/Widgets/PowerModeButton.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("power-mode-powersaver-symbolic");
#line 64 "../src/Widgets/PowerModeButton.vala"
	gtk_image_set_icon_size (_tmp4_, GTK_ICON_SIZE_LARGE);
#line 64 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp4_);
#line 64 "../src/Widgets/PowerModeButton.vala"
	saver_icon = _tmp4_;
#line 68 "../src/Widgets/PowerModeButton.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Power Saver"));
#line 68 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp5_);
#line 68 "../src/Widgets/PowerModeButton.vala"
	saver_label = _tmp5_;
#line 70 "../src/Widgets/PowerModeButton.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 70 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp6_);
#line 70 "../src/Widgets/PowerModeButton.vala"
	saver_button_box = _tmp6_;
#line 71 "../src/Widgets/PowerModeButton.vala"
	_tmp7_ = saver_button_box;
#line 71 "../src/Widgets/PowerModeButton.vala"
	_tmp8_ = saver_icon;
#line 71 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 72 "../src/Widgets/PowerModeButton.vala"
	_tmp9_ = saver_button_box;
#line 72 "../src/Widgets/PowerModeButton.vala"
	_tmp10_ = saver_label;
#line 72 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 74 "../src/Widgets/PowerModeButton.vala"
	_tmp11_ = (GtkCheckButton*) gtk_check_button_new ();
#line 74 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp11_);
#line 74 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->saver_radio);
#line 74 "../src/Widgets/PowerModeButton.vala"
	self->priv->saver_radio = _tmp11_;
#line 75 "../src/Widgets/PowerModeButton.vala"
	_tmp12_ = self->priv->saver_radio;
#line 75 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "image-button");
#line 76 "../src/Widgets/PowerModeButton.vala"
	_tmp13_ = saver_button_box;
#line 76 "../src/Widgets/PowerModeButton.vala"
	_tmp14_ = self->priv->saver_radio;
#line 76 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp13_, (GtkWidget*) _tmp14_);
#line 78 "../src/Widgets/PowerModeButton.vala"
	_tmp15_ = (GtkImage*) gtk_image_new_from_icon_name ("power-mode-balanced-symbolic");
#line 78 "../src/Widgets/PowerModeButton.vala"
	gtk_image_set_icon_size (_tmp15_, GTK_ICON_SIZE_LARGE);
#line 78 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp15_);
#line 78 "../src/Widgets/PowerModeButton.vala"
	balanced_icon = _tmp15_;
#line 82 "../src/Widgets/PowerModeButton.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (_ ("Balanced"));
#line 82 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp16_);
#line 82 "../src/Widgets/PowerModeButton.vala"
	balanced_label = _tmp16_;
#line 84 "../src/Widgets/PowerModeButton.vala"
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 84 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp17_);
#line 84 "../src/Widgets/PowerModeButton.vala"
	balanced_button_box = _tmp17_;
#line 85 "../src/Widgets/PowerModeButton.vala"
	_tmp18_ = balanced_button_box;
#line 85 "../src/Widgets/PowerModeButton.vala"
	_tmp19_ = balanced_icon;
#line 85 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 86 "../src/Widgets/PowerModeButton.vala"
	_tmp20_ = balanced_button_box;
#line 86 "../src/Widgets/PowerModeButton.vala"
	_tmp21_ = balanced_label;
#line 86 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 88 "../src/Widgets/PowerModeButton.vala"
	_tmp22_ = self->priv->saver_radio;
#line 88 "../src/Widgets/PowerModeButton.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 88 "../src/Widgets/PowerModeButton.vala"
	_tmp24_ = (GtkCheckButton*) gtk_check_button_new ();
#line 88 "../src/Widgets/PowerModeButton.vala"
	gtk_check_button_set_group (_tmp24_, _tmp23_);
#line 88 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (_tmp23_);
#line 88 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp24_);
#line 88 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->balanced_radio);
#line 88 "../src/Widgets/PowerModeButton.vala"
	self->priv->balanced_radio = _tmp24_;
#line 91 "../src/Widgets/PowerModeButton.vala"
	_tmp25_ = self->priv->balanced_radio;
#line 91 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp25_, "image-button");
#line 92 "../src/Widgets/PowerModeButton.vala"
	_tmp26_ = balanced_button_box;
#line 92 "../src/Widgets/PowerModeButton.vala"
	_tmp27_ = self->priv->balanced_radio;
#line 92 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp26_, (GtkWidget*) _tmp27_);
#line 94 "../src/Widgets/PowerModeButton.vala"
	_tmp28_ = (GtkImage*) gtk_image_new_from_icon_name ("power-mode-performance-symbolic");
#line 94 "../src/Widgets/PowerModeButton.vala"
	gtk_image_set_icon_size (_tmp28_, GTK_ICON_SIZE_LARGE);
#line 94 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp28_);
#line 94 "../src/Widgets/PowerModeButton.vala"
	performance_icon = _tmp28_;
#line 98 "../src/Widgets/PowerModeButton.vala"
	_tmp29_ = (GtkLabel*) gtk_label_new (_ ("Performance"));
#line 98 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp29_);
#line 98 "../src/Widgets/PowerModeButton.vala"
	performance_label = _tmp29_;
#line 100 "../src/Widgets/PowerModeButton.vala"
	_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 100 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp30_);
#line 100 "../src/Widgets/PowerModeButton.vala"
	performance_button_box = _tmp30_;
#line 101 "../src/Widgets/PowerModeButton.vala"
	_tmp31_ = performance_button_box;
#line 101 "../src/Widgets/PowerModeButton.vala"
	_tmp32_ = performance_icon;
#line 101 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 102 "../src/Widgets/PowerModeButton.vala"
	_tmp33_ = performance_button_box;
#line 102 "../src/Widgets/PowerModeButton.vala"
	_tmp34_ = performance_label;
#line 102 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 104 "../src/Widgets/PowerModeButton.vala"
	_tmp35_ = self->priv->saver_radio;
#line 104 "../src/Widgets/PowerModeButton.vala"
	_tmp36_ = _g_object_ref0 (_tmp35_);
#line 104 "../src/Widgets/PowerModeButton.vala"
	_tmp37_ = (GtkCheckButton*) gtk_check_button_new ();
#line 104 "../src/Widgets/PowerModeButton.vala"
	gtk_check_button_set_group (_tmp37_, _tmp36_);
#line 104 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (_tmp36_);
#line 104 "../src/Widgets/PowerModeButton.vala"
	g_object_ref_sink (_tmp37_);
#line 104 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->performance_radio);
#line 104 "../src/Widgets/PowerModeButton.vala"
	self->priv->performance_radio = _tmp37_;
#line 107 "../src/Widgets/PowerModeButton.vala"
	_tmp38_ = self->priv->performance_radio;
#line 107 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp38_, "image-button");
#line 108 "../src/Widgets/PowerModeButton.vala"
	_tmp39_ = performance_button_box;
#line 108 "../src/Widgets/PowerModeButton.vala"
	_tmp40_ = self->priv->performance_radio;
#line 108 "../src/Widgets/PowerModeButton.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp39_, (GtkWidget*) _tmp40_);
#line 110 "../src/Widgets/PowerModeButton.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 111 "../src/Widgets/PowerModeButton.vala"
	_tmp41_ = header;
#line 111 "../src/Widgets/PowerModeButton.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp41_);
#line 113 "../src/Widgets/PowerModeButton.vala"
	_tmp42_ = power_power_mode_button_pprofile;
#line 113 "../src/Widgets/PowerModeButton.vala"
	_tmp43_ = power_power_profile_get_profiles (_tmp42_, &_tmp44_);
#line 113 "../src/Widgets/PowerModeButton.vala"
	_tmp43__length1 = _tmp44_;
#line 113 "../src/Widgets/PowerModeButton.vala"
	_tmp45_ = _tmp43_;
#line 113 "../src/Widgets/PowerModeButton.vala"
	_tmp45__length1 = _tmp43__length1;
#line 681 "PowerModeButton.c"
	{
		GHashTable** profile_collection = NULL;
		gint profile_collection_length1 = 0;
		gint _profile_collection_size_ = 0;
		gint profile_it = 0;
#line 113 "../src/Widgets/PowerModeButton.vala"
		profile_collection = _tmp45_;
#line 113 "../src/Widgets/PowerModeButton.vala"
		profile_collection_length1 = _tmp45__length1;
#line 113 "../src/Widgets/PowerModeButton.vala"
		for (profile_it = 0; profile_it < profile_collection_length1; profile_it = profile_it + 1) {
#line 693 "PowerModeButton.c"
			GHashTable* profile = NULL;
#line 113 "../src/Widgets/PowerModeButton.vala"
			profile = profile_collection[profile_it];
#line 697 "PowerModeButton.c"
			{
				GHashTable* _tmp46_;
				gconstpointer _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				GQuark _tmp51_ = 0U;
#line 114 "../src/Widgets/PowerModeButton.vala"
				static GQuark _tmp50_label0 = 0;
#line 114 "../src/Widgets/PowerModeButton.vala"
				static GQuark _tmp50_label1 = 0;
#line 114 "../src/Widgets/PowerModeButton.vala"
				static GQuark _tmp50_label2 = 0;
#line 114 "../src/Widgets/PowerModeButton.vala"
				_tmp46_ = profile;
#line 114 "../src/Widgets/PowerModeButton.vala"
				_tmp47_ = g_hash_table_lookup (_tmp46_, "Profile");
#line 114 "../src/Widgets/PowerModeButton.vala"
				_tmp48_ = g_variant_get_string ((GVariant*) _tmp47_, NULL);
#line 114 "../src/Widgets/PowerModeButton.vala"
				_tmp49_ = _tmp48_;
#line 114 "../src/Widgets/PowerModeButton.vala"
				_tmp51_ = (NULL == _tmp49_) ? 0 : g_quark_from_string (_tmp49_);
#line 114 "../src/Widgets/PowerModeButton.vala"
				if (_tmp51_ == ((0 != _tmp50_label0) ? _tmp50_label0 : (_tmp50_label0 = g_quark_from_static_string ("power-saver")))) {
#line 114 "../src/Widgets/PowerModeButton.vala"
					switch (0) {
#line 724 "PowerModeButton.c"
						default:
						{
							GtkCheckButton* _tmp52_;
#line 116 "../src/Widgets/PowerModeButton.vala"
							_tmp52_ = self->priv->saver_radio;
#line 116 "../src/Widgets/PowerModeButton.vala"
							gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp52_);
#line 117 "../src/Widgets/PowerModeButton.vala"
							break;
#line 734 "PowerModeButton.c"
						}
					}
				} else if (_tmp51_ == ((0 != _tmp50_label1) ? _tmp50_label1 : (_tmp50_label1 = g_quark_from_static_string ("balanced")))) {
#line 114 "../src/Widgets/PowerModeButton.vala"
					switch (0) {
#line 740 "PowerModeButton.c"
						default:
						{
							GtkCheckButton* _tmp53_;
#line 119 "../src/Widgets/PowerModeButton.vala"
							_tmp53_ = self->priv->balanced_radio;
#line 119 "../src/Widgets/PowerModeButton.vala"
							gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp53_);
#line 120 "../src/Widgets/PowerModeButton.vala"
							break;
#line 750 "PowerModeButton.c"
						}
					}
				} else if (_tmp51_ == ((0 != _tmp50_label2) ? _tmp50_label2 : (_tmp50_label2 = g_quark_from_static_string ("performance")))) {
#line 114 "../src/Widgets/PowerModeButton.vala"
					switch (0) {
#line 756 "PowerModeButton.c"
						default:
						{
							GtkCheckButton* _tmp54_;
#line 122 "../src/Widgets/PowerModeButton.vala"
							_tmp54_ = self->priv->performance_radio;
#line 122 "../src/Widgets/PowerModeButton.vala"
							gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp54_);
#line 123 "../src/Widgets/PowerModeButton.vala"
							break;
#line 766 "PowerModeButton.c"
						}
					}
				}
			}
		}
#line 113 "../src/Widgets/PowerModeButton.vala"
		profile_collection = (_vala_array_free (profile_collection, profile_collection_length1, (GDestroyNotify) g_hash_table_unref), NULL);
#line 774 "PowerModeButton.c"
	}
#line 127 "../src/Widgets/PowerModeButton.vala"
	power_power_mode_button_update_active_profile (self);
#line 129 "../src/Widgets/PowerModeButton.vala"
	_tmp55_ = self->priv->saver_radio;
#line 129 "../src/Widgets/PowerModeButton.vala"
	g_signal_connect_object (_tmp55_, "toggled", (GCallback) __power_power_mode_button___lambda12__gtk_check_button_toggled, self, 0);
#line 135 "../src/Widgets/PowerModeButton.vala"
	_tmp56_ = self->priv->balanced_radio;
#line 135 "../src/Widgets/PowerModeButton.vala"
	g_signal_connect_object (_tmp56_, "toggled", (GCallback) __power_power_mode_button___lambda13__gtk_check_button_toggled, self, 0);
#line 141 "../src/Widgets/PowerModeButton.vala"
	_tmp57_ = self->priv->performance_radio;
#line 141 "../src/Widgets/PowerModeButton.vala"
	g_signal_connect_object (_tmp57_, "toggled", (GCallback) __power_power_mode_button___lambda14__gtk_check_button_toggled, self, 0);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (performance_button_box);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (performance_label);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (performance_icon);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (balanced_button_box);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (balanced_label);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (balanced_icon);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (saver_button_box);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (saver_label);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (saver_icon);
#line 55 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (header);
#line 55 "../src/Widgets/PowerModeButton.vala"
	return obj;
#line 812 "PowerModeButton.c"
}

static void
power_power_mode_button_class_init (PowerPowerModeButtonClass * klass,
                                    gpointer klass_data)
{
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GSettingsSchema* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 22 "../src/Widgets/PowerModeButton.vala"
	power_power_mode_button_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/PowerModeButton.vala"
	g_type_class_adjust_private_offset (klass, &PowerPowerModeButton_private_offset);
#line 22 "../src/Widgets/PowerModeButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_power_mode_button_get_property;
#line 22 "../src/Widgets/PowerModeButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_power_mode_button_set_property;
#line 22 "../src/Widgets/PowerModeButton.vala"
	G_OBJECT_CLASS (klass)->constructor = power_power_mode_button_constructor;
#line 22 "../src/Widgets/PowerModeButton.vala"
	G_OBJECT_CLASS (klass)->finalize = power_power_mode_button_finalize;
#line 22 "../src/Widgets/PowerModeButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY, power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY] = g_param_spec_string ("settings-key", "settings-key", "settings-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "../src/Widgets/PowerModeButton.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 39 "../src/Widgets/PowerModeButton.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, "io.elementary.settings-daemon.power", TRUE);
#line 39 "../src/Widgets/PowerModeButton.vala"
	schema = _tmp1_;
#line 40 "../src/Widgets/PowerModeButton.vala"
	_tmp4_ = schema;
#line 40 "../src/Widgets/PowerModeButton.vala"
	if (_tmp4_ != NULL) {
#line 850 "PowerModeButton.c"
		GSettingsSchema* _tmp5_;
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp5_ = schema;
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp3_ = g_settings_schema_has_key (_tmp5_, "profile-plugged-in");
#line 856 "PowerModeButton.c"
	} else {
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp3_ = FALSE;
#line 860 "PowerModeButton.c"
	}
#line 40 "../src/Widgets/PowerModeButton.vala"
	if (_tmp3_) {
#line 864 "PowerModeButton.c"
		GSettingsSchema* _tmp6_;
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp6_ = schema;
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp2_ = g_settings_schema_has_key (_tmp6_, "profile-on-good-battery");
#line 870 "PowerModeButton.c"
	} else {
#line 40 "../src/Widgets/PowerModeButton.vala"
		_tmp2_ = FALSE;
#line 874 "PowerModeButton.c"
	}
#line 40 "../src/Widgets/PowerModeButton.vala"
	if (_tmp2_) {
#line 878 "PowerModeButton.c"
		GSettings* _tmp7_;
#line 41 "../src/Widgets/PowerModeButton.vala"
		_tmp7_ = g_settings_new ("io.elementary.settings-daemon.power");
#line 41 "../src/Widgets/PowerModeButton.vala"
		_g_object_unref0 (power_power_mode_button_settings);
#line 41 "../src/Widgets/PowerModeButton.vala"
		power_power_mode_button_settings = _tmp7_;
#line 886 "PowerModeButton.c"
	} else {
#line 43 "../src/Widgets/PowerModeButton.vala"
		g_critical ("PowerModeButton.vala:43: settings-daemon schema not found");
#line 44 "../src/Widgets/PowerModeButton.vala"
		power_power_mode_button_set_successfully_initialized (FALSE);
#line 892 "PowerModeButton.c"
	}
	{
		PowerPowerProfile* _tmp8_ = NULL;
		PowerPowerProfile* _tmp9_;
		PowerPowerProfile* _tmp10_;
#line 48 "../src/Widgets/PowerModeButton.vala"
		_tmp9_ = (PowerPowerProfile*) g_initable_new (POWER_TYPE_POWER_PROFILE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_POWER_PROFILES_DAEMON_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_POWER_PROFILES_DAEMON_PATH, "g-interface-name", "net.hadess.PowerProfiles", NULL);
#line 48 "../src/Widgets/PowerModeButton.vala"
		_tmp8_ = (PowerPowerProfile*) _tmp9_;
#line 48 "../src/Widgets/PowerModeButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 904 "PowerModeButton.c"
			goto __catch0_g_error;
		}
#line 48 "../src/Widgets/PowerModeButton.vala"
		_tmp10_ = _tmp8_;
#line 48 "../src/Widgets/PowerModeButton.vala"
		_tmp8_ = NULL;
#line 48 "../src/Widgets/PowerModeButton.vala"
		_g_object_unref0 (power_power_mode_button_pprofile);
#line 48 "../src/Widgets/PowerModeButton.vala"
		power_power_mode_button_pprofile = _tmp10_;
#line 47 "../src/Widgets/PowerModeButton.vala"
		_g_object_unref0 (_tmp8_);
#line 917 "PowerModeButton.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 47 "../src/Widgets/PowerModeButton.vala"
		e = _inner_error0_;
#line 47 "../src/Widgets/PowerModeButton.vala"
		_inner_error0_ = NULL;
#line 50 "../src/Widgets/PowerModeButton.vala"
		_tmp11_ = e;
#line 50 "../src/Widgets/PowerModeButton.vala"
		_tmp12_ = _tmp11_->message;
#line 50 "../src/Widgets/PowerModeButton.vala"
		g_critical ("PowerModeButton.vala:50: %s", _tmp12_);
#line 51 "../src/Widgets/PowerModeButton.vala"
		power_power_mode_button_set_successfully_initialized (FALSE);
#line 47 "../src/Widgets/PowerModeButton.vala"
		_g_error_free0 (e);
#line 939 "PowerModeButton.c"
	}
	__finally0:
#line 47 "../src/Widgets/PowerModeButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/Widgets/PowerModeButton.vala"
		_g_settings_schema_unref0 (schema);
#line 47 "../src/Widgets/PowerModeButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "../src/Widgets/PowerModeButton.vala"
		g_clear_error (&_inner_error0_);
#line 950 "PowerModeButton.c"
	}
#line 38 "../src/Widgets/PowerModeButton.vala"
	_g_settings_schema_unref0 (schema);
#line 954 "PowerModeButton.c"
}

static void
power_power_mode_button_instance_init (PowerPowerModeButton * self,
                                       gpointer klass)
{
#line 22 "../src/Widgets/PowerModeButton.vala"
	self->priv = power_power_mode_button_get_instance_private (self);
#line 963 "PowerModeButton.c"
}

static void
power_power_mode_button_finalize (GObject * obj)
{
	PowerPowerModeButton * self;
#line 22 "../src/Widgets/PowerModeButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
#line 28 "../src/Widgets/PowerModeButton.vala"
	_g_free0 (self->priv->_settings_key);
#line 30 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->saver_radio);
#line 31 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->balanced_radio);
#line 32 "../src/Widgets/PowerModeButton.vala"
	_g_object_unref0 (self->priv->performance_radio);
#line 22 "../src/Widgets/PowerModeButton.vala"
	G_OBJECT_CLASS (power_power_mode_button_parent_class)->finalize (obj);
#line 982 "PowerModeButton.c"
}

static GType
power_power_mode_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerPowerModeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_power_mode_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerPowerModeButton), 0, (GInstanceInitFunc) power_power_mode_button_instance_init, NULL };
	GType power_power_mode_button_type_id;
	power_power_mode_button_type_id = g_type_register_static (gtk_box_get_type (), "PowerPowerModeButton", &g_define_type_info, 0);
	PowerPowerModeButton_private_offset = g_type_add_instance_private (power_power_mode_button_type_id, sizeof (PowerPowerModeButtonPrivate));
	return power_power_mode_button_type_id;
}

GType
power_power_mode_button_get_type (void)
{
	static volatile gsize power_power_mode_button_type_id__once = 0;
	if (g_once_init_enter (&power_power_mode_button_type_id__once)) {
		GType power_power_mode_button_type_id;
		power_power_mode_button_type_id = power_power_mode_button_get_type_once ();
		g_once_init_leave (&power_power_mode_button_type_id__once, power_power_mode_button_type_id);
	}
	return power_power_mode_button_type_id__once;
}

static void
_vala_power_power_mode_button_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PowerPowerModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
#line 22 "../src/Widgets/PowerModeButton.vala"
	switch (property_id) {
#line 22 "../src/Widgets/PowerModeButton.vala"
		case POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY:
#line 22 "../src/Widgets/PowerModeButton.vala"
		g_value_set_string (value, power_power_mode_button_get_settings_key (self));
#line 22 "../src/Widgets/PowerModeButton.vala"
		break;
#line 1023 "PowerModeButton.c"
		default:
#line 22 "../src/Widgets/PowerModeButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/PowerModeButton.vala"
		break;
#line 1029 "PowerModeButton.c"
	}
}

static void
_vala_power_power_mode_button_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PowerPowerModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
#line 22 "../src/Widgets/PowerModeButton.vala"
	switch (property_id) {
#line 22 "../src/Widgets/PowerModeButton.vala"
		case POWER_POWER_MODE_BUTTON_SETTINGS_KEY_PROPERTY:
#line 22 "../src/Widgets/PowerModeButton.vala"
		power_power_mode_button_set_settings_key (self, g_value_get_string (value));
#line 22 "../src/Widgets/PowerModeButton.vala"
		break;
#line 1049 "PowerModeButton.c"
		default:
#line 22 "../src/Widgets/PowerModeButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/PowerModeButton.vala"
		break;
#line 1055 "PowerModeButton.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

